
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "parser.ypp"

/*
   parser.yy

   Qore Programming Language

   Copyright 2003 - 2010 David Nichols

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include <qore/intern/BreakStatement.h>
#include <qore/intern/ContinueStatement.h>
#include <qore/intern/ReturnStatement.h>
#include <qore/intern/RethrowStatement.h>
#include <qore/intern/ThreadExitStatement.h>
#include <qore/intern/ExpressionStatement.h>
#include <qore/intern/DoWhileStatement.h>
#include <qore/intern/SummarizeStatement.h>
#include <qore/intern/ContextStatement.h>
#include <qore/intern/IfStatement.h>
#include <qore/intern/WhileStatement.h>
#include <qore/intern/ForStatement.h>
#include <qore/intern/ForEachStatement.h>
#include <qore/intern/TryStatement.h>
#include <qore/intern/ThrowStatement.h>
#include <qore/intern/StatementBlock.h>
#include <qore/intern/ParserSupport.h>
#include <qore/intern/SwitchStatement.h>
#include <qore/intern/CaseNodeWithOperator.h>
#include <qore/intern/CaseNodeRegex.h>
#include <qore/intern/OnBlockExitStatement.h>

#include "parser.h"

#include <qore/intern/QoreClassIntern.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <memory>
#include <utility>

#define YYINITDEPTH 300
//#define YYDEBUG 1

#define YYLLOC_DEFAULT(Current, Rhs, N)                                \
          do                                                           \
            if (N) {                                                   \
                (Current).first_line   = YYRHSLOC(Rhs, 1).first_line;  \
                (Current).last_line    = YYRHSLOC(Rhs, N).last_line;   \
            }                                                          \
            else {                                                     \
                (Current).first_line   = (Current).last_line   =       \
                  YYRHSLOC(Rhs, 0).last_line;                          \
            }                                                          \
          while (0)

class HashElement {
public:
   char *key;
   AbstractQoreNode *value;
 
   DLLLOCAL HashElement(AbstractQoreNode *k, AbstractQoreNode *v);
   DLLLOCAL HashElement(int tag, char *constant, AbstractQoreNode *v);
   DLLLOCAL ~HashElement();
};

static AbstractQoreNode *makeErrorTree(AbstractQoreNode *left, AbstractQoreNode *right) {
   discard(left, 0);
   discard(right, 0);
   return &False;
}

static int checkParseOption(int o) {
   return getParseOptions() & o;
}

static void addUserFunctionVariant(char *name, UserFunctionVariant *variant) {
   getProgram()->registerUserFunctionVariant(name, variant); 
   // make sure definition was legal
   if (checkParseOption(PO_NO_SUBROUTINE_DEFS))
      parse_error("function '%s()' defined (conflicts with parse option NO_SUBROUTINE_DEFS)", name);
}

HashElement::HashElement(AbstractQoreNode *k, AbstractQoreNode *v) {
   //tracein("HashElement::HashElement()");
   if (!k || k->getType() != NT_STRING) {
      parse_error("hash member name must be a string value!");
      key = strdup("");
   }
   else
      key = strdup(reinterpret_cast<QoreStringNode *>(k)->getBuffer());
   k->deref(0);
   value = v;
   //traceout("HashElement::HashElement()");
}

HashElement::HashElement(int tag, char *constant, AbstractQoreNode *v) {
   //tracein("HashElement::HashElement()");
   key = (char *)malloc(sizeof(char) * strlen(constant) + 2);
   key[0] = tag; // mark as constant
   strcpy(key + 1, constant);
   value = v;
   free(constant);
   //traceout("HashElement::HashElement()");
}

HashElement::~HashElement() {
   free(key);
}

// for constant definitions
class ConstNode {
   public:
      class NamedScope *name;
      AbstractQoreNode *value;

      DLLLOCAL inline ConstNode(char *n, AbstractQoreNode *v) { name = new NamedScope(n); value = v; }
      DLLLOCAL inline ~ConstNode() { delete name; }
};

class ObjClassDef {
public:
   NamedScope *name;
   QoreClass *oc;

   DLLLOCAL inline ObjClassDef(char *n, class QoreClass *o) { name = new NamedScope(n); oc = o; }
   DLLLOCAL inline ~ObjClassDef() { delete name; }
};

#define NSN_OCD   1
#define NSN_CONST 2
#define NSN_NS    3

struct NSNode {
   int type;
   union {
      class ObjClassDef *ocd;
      class ConstNode  *cn;
      class QoreNamespace  *ns;
   } n;
   DLLLOCAL NSNode(class ObjClassDef *o) { type = NSN_OCD; n.ocd = o; }
   DLLLOCAL NSNode(class ConstNode  *c) { type = NSN_CONST; n.cn = c; }
   DLLLOCAL NSNode(class QoreNamespace  *s) { type = NSN_NS; n.ns = s; }
};

static void addNSNode(class QoreNamespace *ns, struct NSNode *n) {
   switch (n->type) {
      case NSN_OCD:
	 ns->addClass(n->n.ocd->name, n->n.ocd->oc);
	 delete n->n.cn;
	 break;
      case NSN_CONST:
	 ns->parseAddConstant(n->n.cn->name, n->n.cn->value);
	 delete n->n.cn;
	 break;
      case NSN_NS:
	 ns->parseAddNamespace(n->n.ns);
	 break;
   }
   delete n;
}

static QoreListNode *make_list(AbstractQoreNode *a1, AbstractQoreNode *a2) {
   QoreListNode *l = new QoreListNode;
   l->push(a1);
   l->push(a2);
   return l;
}

static QoreListNode *splice_expressions(AbstractQoreNode *a1, AbstractQoreNode *a2) {
   //tracein("splice_expressions()");
   if (a1 && a1->getType() == NT_LIST) {
      QoreListNode *l = reinterpret_cast<QoreListNode *>(a1);
      if (!l->isFinalized()) {
	 //printd(5, "LIST x\n");
	 l->push(a2);
	 return l;
      }
   }
   return make_list(a1, a2);
}

typedef std::pair<char *, QoreMemberInfo *> member_pair_t;

struct MemberInfo {
   char *name;
   QoreMemberInfo *memberInfo;

   DLLLOCAL MemberInfo(char *n, QoreMemberInfo *mi) : name(n), memberInfo(mi)  {
      if (!mi->parseHasTypeInfo() && getProgram()->getParseOptions() & PO_REQUIRE_TYPES)
	 parse_error("member $.%s declared without type information, but parse options require type information for all declarations", name);
   }
   DLLLOCAL ~MemberInfo() {
      if (name)
	 free(name);
      delete memberInfo;
   }
   DLLLOCAL member_pair_t getPair() {
      member_pair_t m = std::make_pair(name, memberInfo);
      name = 0;
      memberInfo = 0;
      return m;
   }
};

class MemberList : private member_map_t {
protected:
   DLLLOCAL MemberList() {
   }

public:
   DLLLOCAL MemberList(MemberInfo *member) {
      insert(member->getPair());
      delete member;
   }

   DLLLOCAL ~MemberList() {
      member_map_t::iterator i;
      while ((i = begin()) != end()) {
	 char *name = i->first;
	 delete i->second;
	 erase(i);
	 free(name);
      }
   }

   // takes over ownership of name and typeInfo
   DLLLOCAL int add(MemberInfo *member) {
      std::auto_ptr<MemberInfo> mem(member);
      if (find(member->name) != end()) {
	 parse_error("duplicate member declaration '%s'", member->name);
	 return -1;
      }

      // add new member to list
      insert(member->getPair());
      return 0;
   }

   DLLLOCAL void mergePrivateMembers(QoreClass *qc) {
      member_map_t::iterator i;
      while ((i = begin()) != end()) {
	 qc->parseAddPrivateMember(i->first, i->second);
	 erase(i);
      }
   }

   DLLLOCAL void mergePublicMembers(QoreClass *qc) {
      member_map_t::iterator i;
      if (empty()) {
	 qc->parseSetEmptyPublicMemberDeclaration();
	 return;
      }
      while ((i = begin()) != end()) {
	 qc->parseAddPublicMember(i->first, i->second);
	 erase(i);
      }
   }
};

class EmptyPublicMemberList : public MemberList {
public:
   DLLLOCAL EmptyPublicMemberList() {
   }
};

static inline void parseAddConstant(NamedScope *name, AbstractQoreNode *value) {
   getRootNS()->rootAddConstant(name, value);
}

static inline void addClass(NamedScope *name, QoreClass *oc) {
   getRootNS()->rootAddClass(name, oc);
}

static inline QoreClass *parseFindClass(char *name) {
   QoreClass *c = getRootNS()->rootFindClass(name);
   if (!c)
      parse_error("reference to undefined class '%s'", name);

   return c;
}

static AbstractQoreNode *process_dot(AbstractQoreNode *l, AbstractQoreNode *r) {
   qore_type_t rtype = r->getType();
   if (rtype == NT_BAREWORD) {
      BarewordNode *b = reinterpret_cast<BarewordNode *>(r);
      AbstractQoreNode *rv = new QoreTreeNode(l, OP_OBJECT_REF, b->makeQoreStringNode());
      b->deref();
      return rv;
   }

   if (rtype == NT_FUNCTION_CALL) {
      FunctionCallNode *f = reinterpret_cast<FunctionCallNode *>(r);
      assert(!f->getFunction());
      MethodCallNode *m = new MethodCallNode(f->takeName(), f->take_args());
      f->deref();

      return new QoreTreeNode(l, OP_OBJECT_FUNC_REF, m);
   }

   return new QoreTreeNode(l, OP_OBJECT_REF, r);
}

// returns 0 for OK, -1 for error
static int check_lvalue(AbstractQoreNode *node) {
   qore_type_t ntype = node->getType();
   //printd(5, "type=%s\n", node->getTypeName());
   if (ntype == NT_VARREF)
      return 0;

   if (ntype == NT_TREE) {
      QoreTreeNode *t = reinterpret_cast<QoreTreeNode *>(node);
      if (t->getOp() == OP_LIST_REF || t->getOp() == OP_OBJECT_REF)
	 return check_lvalue(t->left);
      else
	 return -1;
   }
   if (ntype == NT_SELF_VARREF)
      return 0;
   return -1;
}

static inline int check_vars(AbstractQoreNode *n) {
   if (n && n->getType() == NT_LIST) {
      QoreListNode *l = reinterpret_cast<QoreListNode *>(n);
      for (unsigned i = 0; i < l->size(); i++)
	 if (l->retrieve_entry(i)->getType() != NT_VARREF)
	    return 1;
      return 0;
   }
   return check_lvalue(n);
}

// returns true if the node needs run-time evaluation, false if not
static bool needsEval(AbstractQoreNode *n) {
   if (!n)
      return false;

   qore_type_t ntype = n->getType();

   // if it's a constant or a function reference
   if (ntype == NT_BAREWORD || ntype == NT_CONSTANT || ntype == NT_FUNCREF)
      return false;

   if (ntype == NT_LIST) {
      QoreListNode *l = reinterpret_cast<QoreListNode *>(n);
      if (l->needs_eval()) {
	 for (unsigned i = 0; i <l->size(); i++) {
	    if (needsEval(l->retrieve_entry(i)))
	       return true;
	 }
	 // here we set needs_eval to false so the list won't be evaluated again
	 l->clearNeedsEval();
      }
      return false;
   }

   if (ntype == NT_HASH) {
      QoreHashNode *h = reinterpret_cast<QoreHashNode *>(n);
      if (h->needs_eval()) {
	 HashIterator hi(h);
	 while (hi.next())
	    if (needsEval(hi.getValue()))
	       return true;
	 // here we set needs_eval to false so the hash won't be evaluated again
	 h->clearNeedsEval();
      }
      return false;
   }
   
   if (ntype == NT_TREE) {
      QoreTreeNode *tree = reinterpret_cast<QoreTreeNode *>(n);

      if (needsEval(tree->left) || (tree->right && needsEval(tree->right)))
	 return true;
      return tree->getOp()->hasEffect();
   }

   //printd(5, "needsEval() type %s = true\n", n->getTypeName());
   // we don't return needs_eval() here because some node types are not meant to be evaluated directly but are also not values
   return !n->is_value();
}

static void const_ok(AbstractQoreNode *v) {
   if (v && v->getType() == NT_FUNCREF)
      parse_error("constants may not be assigned to call references");
   /*
   else if (needsEval(v))
     parse_error("constant expression needs run-time evaluation");
   */
}

static int check_case(const char *op, AbstractQoreNode *exp) {
   // ignore if NULL (= NOTHING)
   if (exp && needsEval(exp)) {
      if (op)
	 parse_error("case expression with '%s' needs run-time evaluation", op);
      else
	 parse_error("case expression needs run-time evaluation", op);
      return -1;
   }
   return 0;
}

static bool hasEffect(AbstractQoreNode *n) {
   if (!n || n->is_value())
      return false;

   ParseNode *pn = dynamic_cast<ParseNode *>(n);
   return pn ? pn->has_effect() : true;
}

/*
static bool hasEffect(AbstractQoreNode *n) {
   // check for expressions with no effect
   qore_type_t ntype = n->getType();
   if (ntype == NT_FUNCTION_CALL || ntype == NT_STATIC_METHOD_CALL 
       || ntype == NT_FIND || ntype == NT_FUNCREFCALL || ntype == NT_SELF_CALL
       || ntype == NT_SCOPE_REF)
      return true;

   if (ntype == NT_TREE)
      return reinterpret_cast<QoreTreeNode *>(n)->op->hasEffect();

   if (ntype == NT_VARREF)
      return reinterpret_cast<VarRefNode *>(n)->hasEffect();

   if (ntype == NT_OPERATOR)
      return reinterpret_cast<QoreOperatorNode *>(n)->hasEffect();

   //printd(5, "hasEffect() node %08p type=%s\n", n, n->getTypeName());
   return false;
}
*/

#define OFM_PRIVATE 1
#define OFM_SYNCED  2
#define OFM_STATIC  4

static int checkMethod(const char *name, BCAList *bcal, RetTypeInfo *returnTypeInfo) {
   bool con = !strcmp(name, "constructor");
   bool dst = !strcmp(name, "destructor");

   // see if a return type is given for special methods
   if (returnTypeInfo && (con || dst)) {
      parse_error("%s methods may not declare a return type", name);
      return -1;
   }

   if (bcal && !con) {
      parse_error("base class constructor lists are only legal when defining constructor() methods");
      return -1;
   }

   return 0;
}

static inline MethodVariantBase *newMethodVariant(const char *name, int mod, int n_sig_first_line, int n_sig_last_line, AbstractQoreNode *params, BCAList *bcal, RetTypeInfo *returnTypeInfo, StatementBlock *b) {

   int64 flags = get_pop_argv_ref() ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS;

   if (bcal && strcmp(name, "constructor")) {
      parse_error("only constructors may have base class constructor arguments");
      delete bcal;
      bcal = 0;
   }
   if (!strcmp(name, "constructor")) {
      if (mod & OFM_SYNCED)
	 parse_error("constructors may not be synchronized");
      if (returnTypeInfo) {
	 parse_error("return type information cannot be defined for constructors");
	 delete returnTypeInfo;
      }
      return new UserConstructorVariant(mod & OFM_PRIVATE, b, n_sig_first_line, n_sig_last_line, params, bcal, flags);
   }
   if (!strcmp(name, "destructor")) {
      if (params) {
	 parse_error("parameters cannot be defined for destructors");
	 params->deref(0);
      }
      if (mod & OFM_SYNCED)
	 parse_error("destructors may not be synchronized");
      if (mod & OFM_PRIVATE)
	 parse_error("destructors cannot be private");
      if (returnTypeInfo) {
	 parse_error("return type information cannot be defined for destructors");
	 delete returnTypeInfo;
      }
      return new UserDestructorVariant(b, n_sig_first_line, n_sig_last_line);
   }
   if (!strcmp(name, "copy") && !(mod & OFM_SYNCED))
      return new UserCopyVariant(mod & OFM_PRIVATE, b, n_sig_first_line, n_sig_last_line, params, returnTypeInfo, mod & OFM_SYNCED);

   return new UserMethodVariant(mod & OFM_PRIVATE, b, n_sig_first_line, n_sig_last_line, params, returnTypeInfo, mod & OFM_SYNCED, flags);
}

static inline void tryAddMethod(int mod, char *n, int n_sig_first_line, int n_sig_last_line, AbstractQoreNode *params, BCAList *bcal, RetTypeInfo *returnTypeInfo, StatementBlock *b) {
   std::auto_ptr<NamedScope> name(new NamedScope(n));

   if (checkMethod(name->getIdentifier(), bcal, returnTypeInfo)) {
      if (params)
	 params->deref(0);
      delete bcal;
      delete b;
      delete returnTypeInfo;
   }
   else {
      MethodVariantBase *m = newMethodVariant(name->getIdentifier(), mod, n_sig_first_line, n_sig_last_line, params, bcal, returnTypeInfo, b);
      // if there are any errors, the function below will delete memory
      getRootNS()->addMethodToClass(name.get(), m, mod & OFM_STATIC);
   }
}

struct MethodNode {
public:
   // name of method
   char *name;
   // method variant to add to class
   MethodVariantBase *m;
   // static flag
   bool static_flag;

   DLLLOCAL inline MethodNode(char *mname, MethodVariantBase *v, bool n_static) : name(mname), m(v), static_flag(n_static) {
   }
   DLLLOCAL inline ~MethodNode() {
      free(name);
      delete m;
   }
   DLLLOCAL inline void addAndDelete(QoreClass *qc) {
      qc->addUserMethod(name, m, static_flag);
      m = 0;
      delete this;
   }
};

static bool is_rewritable_op(Operator *op) {
   return op == OP_ASSIGNMENT || op == OP_PLUS_EQUALS || op == OP_MINUS_EQUALS;
}

static AbstractQoreNode *checkRewriteList(QoreListNode *l) {
   AbstractQoreNode *e0 = l->retrieve_entry(0);
   // rewrite expression if it's a list without parentheses and
   // the first expression has one of the following operators:
   // =, +=, -=
   if (!l->isFinalized() && e0 && e0->getType() == NT_TREE) {
      QoreTreeNode *t = reinterpret_cast<QoreTreeNode *>(e0);
      QoreTreeNode *top = t;
      if (is_rewritable_op(t->getOp())) {
	 //printd(5, "checkRewriteList() rewriting list l=%p finalized=%d size=%d\n", l, l->isFinalized(), l->size());
	 while (t->right && t->right->getType() == NT_TREE
		&& is_rewritable_op(reinterpret_cast<QoreTreeNode *>(t->right)->getOp())) {
	    t = reinterpret_cast<QoreTreeNode *>(t->right);
	 }
	 // take first element from list (the tree) and make it the new expression

	 l->swap(0, t->right);
	 t->right = l;
	 return top;
      }
   }
   return l;
}



/* Line 189 of yacc.c  */
#line 655 "parser.cpp"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_CLASS = 258,
     TOK_RETURN = 259,
     TOK_RETURNS = 260,
     TOK_MY = 261,
     TOK_DO = 262,
     TOK_TRY = 263,
     TOK_THROW = 264,
     TOK_CATCH = 265,
     TOK_WHERE = 266,
     TOK_NULL = 267,
     TOK_WHILE = 268,
     TOK_IF = 269,
     TOK_FOR = 270,
     TOK_SUB = 271,
     TOK_THREAD_EXIT = 272,
     TOK_BREAK = 273,
     TOK_CONTINUE = 274,
     TOK_NOTHING = 275,
     TOK_CONTEXT_ROW = 276,
     TOK_FIND = 277,
     TOK_FOREACH = 278,
     TOK_IN = 279,
     TOK_DELETE = 280,
     TOK_REMOVE = 281,
     TOK_PRIVATE = 282,
     TOK_PUBLIC = 283,
     TOK_SYNCHRONIZED = 284,
     TOK_CONTEXT = 285,
     TOK_SORT_BY = 286,
     TOK_SORT_DESCENDING_BY = 287,
     TOK_SUB_CONTEXT = 288,
     TOK_CONST = 289,
     TOK_SUMMARIZE = 290,
     TOK_BY = 291,
     TOK_NAMESPACE = 292,
     TOK_OUR = 293,
     TOK_RETHROW = 294,
     TOK_SWITCH = 295,
     TOK_CASE = 296,
     TOK_DEFAULT = 297,
     TOK_INHERITS = 298,
     TOK_ELSE = 299,
     TOK_STATIC = 300,
     TOK_FINALLY = 301,
     TOK_INTERFACE = 302,
     TOK_IMPLEMENTS = 303,
     TOK_ABSTRACT = 304,
     TOK_UNREFERENCE = 305,
     P_INCREMENT = 306,
     P_DECREMENT = 307,
     PLUS_EQUALS = 308,
     MINUS_EQUALS = 309,
     AND_EQUALS = 310,
     OR_EQUALS = 311,
     MODULA_EQUALS = 312,
     MULTIPLY_EQUALS = 313,
     DIVIDE_EQUALS = 314,
     XOR_EQUALS = 315,
     SHIFT_LEFT_EQUALS = 316,
     SHIFT_RIGHT_EQUALS = 317,
     TOK_UNSHIFT = 318,
     TOK_PUSH = 319,
     TOK_POP = 320,
     TOK_SHIFT = 321,
     TOK_CHOMP = 322,
     TOK_TRIM = 323,
     LOGICAL_AND = 324,
     LOGICAL_OR = 325,
     LOGICAL_EQ = 326,
     LOGICAL_NE = 327,
     LOGICAL_LE = 328,
     LOGICAL_GE = 329,
     LOGICAL_CMP = 330,
     ABSOLUTE_EQ = 331,
     ABSOLUTE_NE = 332,
     REGEX_MATCH = 333,
     REGEX_NMATCH = 334,
     TOK_EXISTS = 335,
     TOK_INSTANCEOF = 336,
     SHIFT_RIGHT = 337,
     SHIFT_LEFT = 338,
     TOK_ELEMENTS = 339,
     TOK_KEYS = 340,
     TOK_NEW = 341,
     TOK_BACKGROUND = 342,
     TOK_ON_EXIT = 343,
     TOK_ON_SUCCESS = 344,
     TOK_ON_ERROR = 345,
     TOK_MAP = 346,
     TOK_FOLDR = 347,
     TOK_FOLDL = 348,
     TOK_SELECT = 349,
     TOK_SPLICE = 350,
     TOK_EXTRACT = 351,
     INTEGER = 352,
     QFLOAT = 353,
     IDENTIFIER = 354,
     VAR_REF = 355,
     BACKQUOTE = 356,
     SELF_REF = 357,
     KW_IDENTIFIER_OPENPAREN = 358,
     SCOPED_REF = 359,
     CONTEXT_REF = 360,
     COMPLEX_CONTEXT_REF = 361,
     DATETIME = 362,
     QUOTED_WORD = 363,
     BINARY = 364,
     REGEX_SUBST = 365,
     REGEX_TRANS = 366,
     BASE_CLASS_CALL = 367,
     REGEX = 368,
     REGEX_EXTRACT = 369,
     IMPLICIT_ARG_REF = 370,
     DOT_KW_IDENTIFIER = 371,
     QORE_CAST = 372,
     IFX = 373,
     NEG = 374
   };
#endif
/* Tokens.  */
#define TOK_CLASS 258
#define TOK_RETURN 259
#define TOK_RETURNS 260
#define TOK_MY 261
#define TOK_DO 262
#define TOK_TRY 263
#define TOK_THROW 264
#define TOK_CATCH 265
#define TOK_WHERE 266
#define TOK_NULL 267
#define TOK_WHILE 268
#define TOK_IF 269
#define TOK_FOR 270
#define TOK_SUB 271
#define TOK_THREAD_EXIT 272
#define TOK_BREAK 273
#define TOK_CONTINUE 274
#define TOK_NOTHING 275
#define TOK_CONTEXT_ROW 276
#define TOK_FIND 277
#define TOK_FOREACH 278
#define TOK_IN 279
#define TOK_DELETE 280
#define TOK_REMOVE 281
#define TOK_PRIVATE 282
#define TOK_PUBLIC 283
#define TOK_SYNCHRONIZED 284
#define TOK_CONTEXT 285
#define TOK_SORT_BY 286
#define TOK_SORT_DESCENDING_BY 287
#define TOK_SUB_CONTEXT 288
#define TOK_CONST 289
#define TOK_SUMMARIZE 290
#define TOK_BY 291
#define TOK_NAMESPACE 292
#define TOK_OUR 293
#define TOK_RETHROW 294
#define TOK_SWITCH 295
#define TOK_CASE 296
#define TOK_DEFAULT 297
#define TOK_INHERITS 298
#define TOK_ELSE 299
#define TOK_STATIC 300
#define TOK_FINALLY 301
#define TOK_INTERFACE 302
#define TOK_IMPLEMENTS 303
#define TOK_ABSTRACT 304
#define TOK_UNREFERENCE 305
#define P_INCREMENT 306
#define P_DECREMENT 307
#define PLUS_EQUALS 308
#define MINUS_EQUALS 309
#define AND_EQUALS 310
#define OR_EQUALS 311
#define MODULA_EQUALS 312
#define MULTIPLY_EQUALS 313
#define DIVIDE_EQUALS 314
#define XOR_EQUALS 315
#define SHIFT_LEFT_EQUALS 316
#define SHIFT_RIGHT_EQUALS 317
#define TOK_UNSHIFT 318
#define TOK_PUSH 319
#define TOK_POP 320
#define TOK_SHIFT 321
#define TOK_CHOMP 322
#define TOK_TRIM 323
#define LOGICAL_AND 324
#define LOGICAL_OR 325
#define LOGICAL_EQ 326
#define LOGICAL_NE 327
#define LOGICAL_LE 328
#define LOGICAL_GE 329
#define LOGICAL_CMP 330
#define ABSOLUTE_EQ 331
#define ABSOLUTE_NE 332
#define REGEX_MATCH 333
#define REGEX_NMATCH 334
#define TOK_EXISTS 335
#define TOK_INSTANCEOF 336
#define SHIFT_RIGHT 337
#define SHIFT_LEFT 338
#define TOK_ELEMENTS 339
#define TOK_KEYS 340
#define TOK_NEW 341
#define TOK_BACKGROUND 342
#define TOK_ON_EXIT 343
#define TOK_ON_SUCCESS 344
#define TOK_ON_ERROR 345
#define TOK_MAP 346
#define TOK_FOLDR 347
#define TOK_FOLDL 348
#define TOK_SELECT 349
#define TOK_SPLICE 350
#define TOK_EXTRACT 351
#define INTEGER 352
#define QFLOAT 353
#define IDENTIFIER 354
#define VAR_REF 355
#define BACKQUOTE 356
#define SELF_REF 357
#define KW_IDENTIFIER_OPENPAREN 358
#define SCOPED_REF 359
#define CONTEXT_REF 360
#define COMPLEX_CONTEXT_REF 361
#define DATETIME 362
#define QUOTED_WORD 363
#define BINARY 364
#define REGEX_SUBST 365
#define REGEX_TRANS 366
#define BASE_CLASS_CALL 367
#define REGEX 368
#define REGEX_EXTRACT 369
#define IMPLICIT_ARG_REF 370
#define DOT_KW_IDENTIFIER 371
#define QORE_CAST 372
#define IFX 373
#define NEG 374




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 588 "parser.ypp"

   int i4;
   int64 integer;
   double decimal;
   QoreStringNode *String;
   char *string;
   BinaryNode *binary;
   AbstractQoreNode *node;
   QoreHashNode *hash;
   QoreListNode *list;
   AbstractStatement *statement;
   class MemberInfo *memberinfo;
   StatementBlock *sblock;
   ContextModList *cmods;
   ContextMod *cmod;
   class HashElement *hashelement;
   UserFunction *userfunc;	
   class MethodNode *methodnode;
   class MemberList *memberlist;
   QoreClass *qoreclass;
   class ConstNode *constnode;
   QoreNamespace *ns;
   class NSNode *nsn;
   class ObjClassDef *classdef;
   DateTimeNode *datetime;
   RegexSubstNode *RegexSubst;
   RegexTransNode *RegexTrans;
   SwitchStatement *switchstmt;
   CaseNode *casenode;
   BCList *sclist;
   class BCNode *sclnode;
   BCAList *bcalist;
   BCANode *bcanode;
   NamedScope *nscope;
   QoreRegexNode *Regex;
   QoreImplicitArgumentNode *implicit_arg;
   RetTypeInfo *returnTypeInfo;



/* Line 214 of yacc.c  */
#line 970 "parser.cpp"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */

/* Line 264 of yacc.c  */
#line 627 "parser.ypp"


#define LEX_PARAMETERS YYSTYPE *lvalp, YYLTYPE *loc, yyscan_t scanner

DLLLOCAL int yylex(LEX_PARAMETERS);

DLLLOCAL void yyerror(YYLTYPE *loc, yyscan_t scanner, const char *str) {
   //printd(5, "yyerror() location: %d-%d: \"%s\"\n", loc->first_line, loc->last_line, str);
   parse_error("%s", str);
}



/* Line 264 of yacc.c  */
#line 1009 "parser.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  185
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   8310

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  145
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  47
/* YYNRULES -- Number of rules.  */
#define YYNRULES  272
/* YYNRULES -- Number of states.  */
#define YYNSTATES  615

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   374

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   136,     2,     2,     2,   130,   123,     2,
     140,   143,   131,   128,   119,   129,   139,   132,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   122,   142,
     126,   120,   127,   121,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   138,   135,   144,   125,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   137,   124,   141,   134,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   133
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    16,    18,
      20,    24,    26,    32,    36,    38,    41,    43,    45,    47,
      49,    55,    61,    65,    68,    70,    72,    74,    76,    79,
      82,    83,    85,    88,    94,    96,    99,   103,   106,   109,
     112,   116,   128,   136,   142,   150,   156,   164,   174,   182,
     185,   188,   191,   194,   196,   199,   200,   203,   208,   213,
     218,   220,   223,   231,   233,   236,   242,   247,   253,   258,
     264,   269,   275,   280,   286,   291,   297,   302,   308,   313,
     318,   322,   327,   331,   335,   338,   346,   347,   349,   356,
     363,   368,   373,   379,   385,   388,   389,   391,   395,   397,
     399,   402,   405,   408,   411,   413,   415,   417,   420,   423,
     426,   430,   435,   439,   444,   448,   451,   456,   460,   464,
     470,   476,   483,   490,   492,   495,   497,   501,   503,   506,
     515,   523,   531,   538,   547,   555,   558,   559,   561,   565,
     570,   575,   577,   580,   582,   584,   586,   589,   592,   593,
     601,   610,   617,   625,   629,   632,   634,   638,   641,   645,
     649,   653,   655,   657,   659,   663,   665,   667,   670,   673,
     676,   680,   684,   689,   692,   696,   700,   705,   707,   709,
     711,   713,   722,   726,   730,   734,   738,   742,   746,   750,
     754,   758,   762,   766,   769,   772,   776,   780,   783,   786,
     789,   792,   795,   798,   801,   804,   807,   810,   813,   816,
     819,   825,   828,   831,   834,   837,   842,   847,   851,   853,
     857,   861,   865,   869,   873,   877,   881,   885,   889,   893,
     897,   901,   905,   909,   913,   917,   921,   925,   929,   933,
     937,   941,   945,   949,   953,   957,   960,   963,   966,   969,
     975,   981,   984,   986,   991,   996,  1000,  1003,  1007,  1010,
    1017,  1025,  1027,  1030,  1033,  1038,  1040,  1043,  1045,  1047,
    1049,  1051,  1053
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     146,     0,    -1,   147,    -1,   146,   147,    -1,   185,    -1,
     166,    -1,   152,    -1,   151,    -1,   178,    -1,   157,    -1,
     137,   155,   141,    -1,   148,    -1,    37,    99,   137,   149,
     141,    -1,    37,    99,   142,    -1,   150,    -1,   149,   150,
      -1,   152,    -1,   151,    -1,   166,    -1,   148,    -1,    34,
      99,   120,   189,   142,    -1,    34,   104,   120,   189,   142,
      -1,   137,   155,   141,    -1,   137,   141,    -1,   157,    -1,
     153,    -1,   157,    -1,   153,    -1,   155,   153,    -1,   155,
     157,    -1,    -1,    99,    -1,   189,   142,    -1,   104,   140,
     165,   143,   142,    -1,   164,    -1,    39,   142,    -1,     9,
     189,   142,    -1,    88,   154,    -1,    89,   154,    -1,    90,
     154,    -1,    33,   158,   154,    -1,    35,   156,   140,   189,
     143,    36,   140,   189,   143,   158,   154,    -1,    30,   156,
     140,   189,   143,   158,   154,    -1,    14,   140,   189,   143,
     154,    -1,    14,   140,   189,   143,   154,    44,   154,    -1,
      13,   140,   189,   143,   154,    -1,     7,   154,    13,   140,
     189,   143,   142,    -1,    15,   140,   165,   142,   165,   142,
     165,   143,   154,    -1,    23,   189,    24,   140,   189,   143,
     154,    -1,   160,   142,    -1,    17,   142,    -1,    18,   142,
      -1,    19,   142,    -1,   161,    -1,     1,   142,    -1,    -1,
     158,   159,    -1,    11,   140,   189,   143,    -1,    31,   140,
     189,   143,    -1,    32,   140,   189,   143,    -1,     4,    -1,
       4,   189,    -1,    40,   140,   189,   143,   137,   162,   141,
      -1,   163,    -1,   162,   163,    -1,    41,    74,   189,   122,
     155,    -1,    41,    74,   189,   122,    -1,    41,    73,   189,
     122,   155,    -1,    41,    73,   189,   122,    -1,    41,    71,
     189,   122,   155,    -1,    41,    71,   189,   122,    -1,    41,
     126,   189,   122,   155,    -1,    41,   126,   189,   122,    -1,
      41,   127,   189,   122,   155,    -1,    41,   127,   189,   122,
      -1,    41,    78,   113,   122,   155,    -1,    41,    78,   113,
     122,    -1,    41,    79,   113,   122,   155,    -1,    41,    79,
     113,   122,    -1,    41,   113,   122,   155,    -1,    41,   113,
     122,    -1,    41,   189,   122,   155,    -1,    41,   189,   122,
      -1,    42,   122,   155,    -1,    42,   122,    -1,     8,   154,
      10,   140,   165,   143,   154,    -1,    -1,   189,    -1,     3,
      99,   167,   137,   170,   141,    -1,     3,   104,   167,   137,
     170,   141,    -1,     3,    99,   167,   142,    -1,     3,   104,
     167,   142,    -1,     3,    99,   167,   137,   141,    -1,     3,
     104,   167,   137,   141,    -1,    43,   168,    -1,    -1,   169,
      -1,   168,   119,   169,    -1,    99,    -1,   104,    -1,    28,
      99,    -1,    28,   104,    -1,    27,    99,    -1,    27,   104,
      -1,   177,    -1,   171,    -1,   172,    -1,   170,   177,    -1,
     170,   171,    -1,   170,   172,    -1,    27,   175,   142,    -1,
      27,   137,   176,   141,    -1,    28,   175,   142,    -1,    28,
     137,   176,   141,    -1,    28,   137,   141,    -1,   102,   142,
      -1,   102,   120,   189,   142,    -1,   104,   102,   142,    -1,
      99,   102,   142,    -1,    99,   102,   120,   189,   142,    -1,
     104,   102,   120,   189,   142,    -1,    99,   102,   140,   165,
     143,   142,    -1,   104,   102,   140,   165,   143,   142,    -1,
     102,    -1,   102,   104,    -1,   174,    -1,   175,   119,   174,
      -1,   173,    -1,   176,   173,    -1,   182,    99,   140,   165,
     143,   179,   184,   153,    -1,   182,   103,   165,   143,   179,
     184,   153,    -1,    99,   140,   165,   143,   179,   184,   153,
      -1,   103,   165,   143,   179,   184,   153,    -1,   182,   104,
     140,   165,   143,   179,   184,   153,    -1,   104,   140,   165,
     143,   179,   184,   153,    -1,   122,   180,    -1,    -1,   181,
      -1,   180,   119,   181,    -1,    99,   140,   165,   143,    -1,
     104,   140,   165,   143,    -1,   183,    -1,   182,   183,    -1,
      27,    -1,    29,    -1,    45,    -1,     5,    99,    -1,     5,
     104,    -1,    -1,    16,    99,   140,   165,   143,   184,   153,
      -1,    29,    16,    99,   140,   165,   143,   184,   153,    -1,
      16,   103,   165,   143,   184,   153,    -1,    29,    16,   103,
     165,   143,   184,   153,    -1,   189,   119,   189,    -1,   189,
     119,    -1,   188,    -1,   187,   119,   188,    -1,   187,   119,
      -1,   191,   122,   189,    -1,    99,   122,   189,    -1,   104,
     122,   189,    -1,   191,    -1,   109,    -1,   186,    -1,   140,
     187,   143,    -1,   104,    -1,   100,    -1,    99,   100,    -1,
     104,   100,    -1,     6,   100,    -1,     6,    99,   100,    -1,
       6,   104,   100,    -1,     6,   140,   186,   143,    -1,    38,
     100,    -1,    38,    99,   100,    -1,    38,   104,   100,    -1,
      38,   140,   186,   143,    -1,    99,    -1,   105,    -1,    21,
      -1,   106,    -1,    22,   189,    24,   189,    11,   140,   189,
     143,    -1,   189,    53,   189,    -1,   189,    54,   189,    -1,
     189,    55,   189,    -1,   189,    56,   189,    -1,   189,    57,
     189,    -1,   189,    58,   189,    -1,   189,    59,   189,    -1,
     189,    60,   189,    -1,   189,    61,   189,    -1,   189,    62,
     189,    -1,   189,   120,   189,    -1,    80,   189,    -1,    84,
     189,    -1,   189,    81,    99,    -1,   189,    81,   104,    -1,
      85,   189,    -1,    63,   189,    -1,    66,   189,    -1,    64,
     189,    -1,    65,   189,    -1,    67,   189,    -1,    68,   189,
      -1,    95,   189,    -1,    96,   189,    -1,    91,   189,    -1,
      92,   189,    -1,    93,   189,    -1,    94,   189,    -1,   189,
     121,   189,   122,   189,    -1,    51,   189,    -1,   189,    51,
      -1,    52,   189,    -1,   189,    52,    -1,   189,   140,   165,
     143,    -1,   112,   140,   165,   143,    -1,   103,   165,   143,
      -1,   102,    -1,   189,    69,   189,    -1,   189,    70,   189,
      -1,   189,   124,   189,    -1,   189,   123,   189,    -1,   189,
     125,   189,    -1,   189,    78,   113,    -1,   189,    79,   113,
      -1,   189,    78,   110,    -1,   189,    78,   111,    -1,   189,
      78,   114,    -1,   189,   127,   189,    -1,   189,   126,   189,
      -1,   189,    75,   189,    -1,   189,    71,   189,    -1,   189,
      76,   189,    -1,   189,    77,   189,    -1,   189,    72,   189,
      -1,   189,    73,   189,    -1,   189,    74,   189,    -1,   189,
      83,   189,    -1,   189,    82,   189,    -1,   189,   128,   189,
      -1,   189,   129,   189,    -1,   189,   130,   189,    -1,   189,
     132,   189,    -1,   189,   131,   189,    -1,   129,   189,    -1,
     134,   189,    -1,   136,   189,    -1,   135,   189,    -1,    86,
      99,   140,   165,   143,    -1,    86,   104,   140,   165,   143,
      -1,    87,   189,    -1,   101,    -1,   189,   138,   189,   144,
      -1,   189,   137,   189,   141,    -1,   189,   139,   189,    -1,
     189,   116,    -1,   140,   189,   143,    -1,   140,   143,    -1,
      16,   140,   165,   143,   184,   153,    -1,    29,    16,   140,
     165,   143,   184,   153,    -1,   115,    -1,    25,   189,    -1,
      26,   189,    -1,   117,   140,   189,   143,    -1,   108,    -1,
     108,   190,    -1,    98,    -1,    97,    -1,   190,    -1,   107,
      -1,    12,    -1,    20,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   841,   841,   842,   846,   847,   855,   864,   871,   872,
     880,   886,   895,   897,   902,   907,   914,   921,   928,   935,
     943,   950,   957,   960,   965,   968,   973,   975,   977,   979,
     985,   986,   990,  1011,  1017,  1019,  1022,  1025,  1028,  1031,
    1034,  1037,  1040,  1043,  1046,  1049,  1052,  1055,  1058,  1064,
    1065,  1072,  1075,  1078,  1079,  1084,  1086,  1097,  1099,  1101,
    1106,  1108,  1112,  1122,  1126,  1134,  1139,  1145,  1150,  1156,
    1161,  1167,  1172,  1178,  1183,  1189,  1193,  1198,  1202,  1207,
    1211,  1216,  1221,  1227,  1231,  1238,  1251,  1252,  1256,  1261,
    1266,  1271,  1277,  1282,  1291,  1294,  1300,  1303,  1310,  1313,
    1316,  1319,  1322,  1325,  1331,  1335,  1340,  1345,  1349,  1354,
    1362,  1365,  1371,  1374,  1377,  1383,  1386,  1389,  1392,  1404,
    1416,  1419,  1434,  1441,  1444,  1450,  1453,  1460,  1463,  1470,
    1474,  1478,  1482,  1489,  1492,  1498,  1501,  1507,  1510,  1517,
    1520,  1526,  1527,  1535,  1536,  1537,  1541,  1553,  1557,  1562,
    1566,  1570,  1574,  1581,  1583,  1599,  1604,  1611,  1616,  1618,
    1620,  1624,  1626,  1628,  1630,  1632,  1634,  1639,  1649,  1652,
    1658,  1667,  1670,  1692,  1700,  1712,  1716,  1739,  1741,  1743,
    1745,  1747,  1749,  1757,  1765,  1773,  1781,  1789,  1797,  1805,
    1813,  1822,  1831,  1857,  1859,  1861,  1864,  1867,  1869,  1886,
    1894,  1911,  1919,  1927,  1935,  1961,  1987,  2006,  2020,  2034,
    2048,  2050,  2058,  2066,  2074,  2082,  2154,  2161,  2165,  2166,
    2167,  2168,  2169,  2170,  2171,  2174,  2177,  2187,  2196,  2198,
    2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,  2207,  2208,
    2209,  2210,  2211,  2212,  2213,  2214,  2220,  2221,  2222,  2287,
    2292,  2297,  2305,  2310,  2311,  2312,  2315,  2318,  2323,  2324,
    2328,  2332,  2336,  2341,  2346,  2352,  2355,  2362,  2363,  2364,
    2365,  2366,  2367
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "\"class\"", "\"return\"", "\"returns\"",
  "\"my\"", "\"do\"", "\"try\"", "\"throw\"", "\"catch\"", "\"where\"",
  "\"NULL\"", "\"while\"", "\"if\"", "\"for\"", "\"sub\"",
  "\"thread_exit\"", "\"break\"", "\"continue\"", "\"NOTHING\"", "\"%%\"",
  "\"find\"", "\"foreach\"", "\"in\"", "\"delete\"", "\"remove\"",
  "\"private\"", "\"public\"", "\"synchronized\"", "\"context\"",
  "\"sortBy\"", "\"sortDescendingBy\"", "\"subcontext\"", "\"const\"",
  "\"summarize\"", "\"by\"", "\"namespace\"", "\"our\"", "\"rethrow\"",
  "\"switch\"", "\"case\"", "\"default\"", "\"inherits\"", "\"else\"",
  "\"static\"", "\"finally\"", "\"interface\"", "\"implements\"",
  "\"abstract\"", "\"unreference\"", "\"++ operator\"", "\"-- operator\"",
  "\"+= operator\"", "\"-= operator\"", "\"&= operator\"",
  "\"|= operator\"", "\"%= operator\"", "\"*= operator\"",
  "\"/= operator\"", "\"^= operator\"", "\"<<= operator\"",
  "\">>= operator\"", "\"unshift\"", "\"push\"", "\"pop\"", "\"shift\"",
  "\"chomp\"", "\"trim\"", "\"&& operator\"", "\"|| operator\"",
  "\"== operator\"", "\"!= operator\"", "\"<= operator\"",
  "\">= operator\"", "\"<=> operator\"", "\"=== operator\"",
  "\"!== operator\"", "\"=~ operator\"", "\"!~ operator\"", "\"exists\"",
  "\"instanceof\"", "\">> operator\"", "\"<< operator\"", "\"elements\"",
  "\"keys\"", "\"new\"", "\"background\"", "\"on_exit\"", "\"on_success\"",
  "\"on_error\"", "\"map\"", "\"foldr\"", "\"foldl\"", "\"select\"",
  "\"splice\"", "\"extract\"", "\"integer value\"",
  "\"floating-point value\"", "\"identifier\"", "\"variable reference\"",
  "\"backquote expression\"", "\"in-object member reference\"",
  "\"identifier or keyword used as function or method identifier\"",
  "\"namespace or class-scoped reference\"", "\"context reference\"",
  "\"named context reference\"", "\"date/time value\"",
  "\"quoted string\"", "\"binary constant value\"",
  "\"regular expression substitution expression\"",
  "\"transliteration expression\"", "\"call to base class method\"",
  "\"regular expression\"", "\"regular expression extraction expression\"",
  "\"implicit argument reference\"",
  "\"keyword used as hash key or object member reference\"",
  "\"cast operator\"", "IFX", "','", "'='", "'?'", "':'", "'&'", "'|'",
  "'^'", "'<'", "'>'", "'+'", "'-'", "'%'", "'*'", "'/'", "NEG", "'~'",
  "'\\\\'", "'!'", "'{'", "'['", "'.'", "'('", "'}'", "';'", "')'", "']'",
  "$accept", "top_level_commands", "top_level_command",
  "top_namespace_decl", "namespace_decls", "namespace_decl",
  "unscoped_const_decl", "scoped_const_decl", "block",
  "statement_or_block", "statements", "optname", "statement",
  "context_mods", "context_mod", "return_statement", "switch_statement",
  "case_block", "case_code", "try_statement", "myexp", "class_def",
  "inheritance_list", "superclass_list", "superclass", "class_attributes",
  "private_member_list", "public_member_list", "member2", "member",
  "member_list", "member_list2", "method_definition",
  "object_outofline_function_def", "base_constructor_list",
  "base_constructors", "base_constructor", "method_modifiers",
  "method_modifier", "return_value", "sub_def", "list", "hash",
  "hash_element", "exp", "string", "scalar", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    44,
      61,    63,    58,    38,   124,    94,    60,    62,    43,    45,
      37,    42,    47,   374,   126,    92,    33,   123,    91,    46,
      40,   125,    59,    41,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   145,   146,   146,   147,   147,   147,   147,   147,   147,
     147,   147,   148,   148,   149,   149,   150,   150,   150,   150,
     151,   152,   153,   153,   154,   154,   155,   155,   155,   155,
     156,   156,   157,   157,   157,   157,   157,   157,   157,   157,
     157,   157,   157,   157,   157,   157,   157,   157,   157,   157,
     157,   157,   157,   157,   157,   158,   158,   159,   159,   159,
     160,   160,   161,   162,   162,   163,   163,   163,   163,   163,
     163,   163,   163,   163,   163,   163,   163,   163,   163,   163,
     163,   163,   163,   163,   163,   164,   165,   165,   166,   166,
     166,   166,   166,   166,   167,   167,   168,   168,   169,   169,
     169,   169,   169,   169,   170,   170,   170,   170,   170,   170,
     171,   171,   172,   172,   172,   173,   173,   173,   173,   173,
     173,   173,   173,   174,   174,   175,   175,   176,   176,   177,
     177,   177,   177,   178,   178,   179,   179,   180,   180,   181,
     181,   182,   182,   183,   183,   183,   184,   184,   184,   185,
     185,   185,   185,   186,   186,   187,   187,   187,   188,   188,
     188,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   190,   190,   191,   191,   191,
     191,   191,   191
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       3,     1,     5,     3,     1,     2,     1,     1,     1,     1,
       5,     5,     3,     2,     1,     1,     1,     1,     2,     2,
       0,     1,     2,     5,     1,     2,     3,     2,     2,     2,
       3,    11,     7,     5,     7,     5,     7,     9,     7,     2,
       2,     2,     2,     1,     2,     0,     2,     4,     4,     4,
       1,     2,     7,     1,     2,     5,     4,     5,     4,     5,
       4,     5,     4,     5,     4,     5,     4,     5,     4,     4,
       3,     4,     3,     3,     2,     7,     0,     1,     6,     6,
       4,     4,     5,     5,     2,     0,     1,     3,     1,     1,
       2,     2,     2,     2,     1,     1,     1,     2,     2,     2,
       3,     4,     3,     4,     3,     2,     4,     3,     3,     5,
       5,     6,     6,     1,     2,     1,     3,     1,     2,     8,
       7,     7,     6,     8,     7,     2,     0,     1,     3,     4,
       4,     1,     2,     1,     1,     1,     2,     2,     0,     7,
       8,     6,     7,     3,     2,     1,     3,     2,     3,     3,
       3,     1,     1,     1,     3,     1,     1,     2,     2,     2,
       3,     3,     4,     2,     3,     3,     4,     1,     1,     1,
       1,     8,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     3,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       5,     2,     2,     2,     2,     4,     4,     3,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     2,     2,     5,
       5,     2,     1,     4,     4,     3,     2,     3,     2,     6,
       7,     1,     2,     2,     4,     1,     2,     1,     1,     1,
       1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,    60,     0,     0,     0,     0,   271,     0,
       0,     0,     0,     0,     0,     0,   272,   179,     0,     0,
       0,     0,   143,   144,    30,    55,     0,    30,     0,     0,
       0,     0,   145,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   268,   267,   177,   166,   252,
     218,    86,   165,   178,   180,   270,   265,   162,     0,   261,
       0,     0,     0,     0,     0,     0,     0,     0,     2,    11,
       7,     6,     9,     0,    53,    34,     5,     8,     0,   141,
       4,   163,     0,   269,   161,    54,    95,    95,     0,     0,
     165,    61,     0,   169,     0,     0,   165,     0,    25,     0,
      24,     0,     0,     0,     0,    86,     0,    86,    86,    50,
      51,    52,     0,     0,   262,   263,     0,    31,     0,     0,
       0,     0,     0,     0,     0,   173,     0,     0,    35,     0,
     211,   213,   198,   200,   201,   199,   202,   203,   193,   194,
     197,     0,     0,   251,    37,    38,    39,   206,   207,   208,
     209,   204,   205,   167,     0,    87,   168,    86,   266,    86,
       0,   245,   246,   248,   247,    27,     0,    26,   177,   165,
     258,     0,   155,     0,   161,     1,     3,    49,   144,     0,
     142,   212,   214,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   256,   154,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    86,    32,     0,     0,     0,     0,
     170,   171,   163,     0,    86,    23,     0,     0,     0,    36,
       0,     0,     0,    86,     0,     0,     0,     0,     0,    86,
      86,     0,     0,     0,     0,    40,    56,     0,     0,     0,
       0,    13,   174,   175,   163,     0,    86,    86,   217,     0,
       0,     0,    10,    28,    29,     0,     0,   157,   164,   257,
       0,    86,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   219,   220,   232,   235,   236,   237,   231,   233,
     234,   226,   227,   224,   228,   225,   195,   196,   239,   238,
     153,   192,     0,   222,   221,   223,   230,   229,   240,   241,
     242,   244,   243,     0,     0,   255,     0,     0,     0,    98,
      99,    94,    96,     0,    90,     0,    91,   172,     0,    22,
       0,    86,     0,     0,    86,     0,   148,   148,     0,     0,
      86,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      19,     0,    14,    17,    16,    18,   176,     0,     0,     0,
     136,   216,   264,   159,   160,     0,     0,   156,     0,   158,
       0,     0,   254,   253,   215,   102,   103,   100,   101,     0,
     143,     0,     0,    86,    92,     0,   105,   106,   104,     0,
      93,     0,     0,     0,     0,    45,    43,     0,   148,     0,
       0,     0,     0,     0,     0,   148,   148,    55,     0,     0,
       0,    20,    21,     0,    12,    15,     0,   249,   250,     0,
      33,   148,   136,   210,    97,   123,     0,   125,     0,     0,
       0,    86,     0,    88,   108,   109,   107,     0,    86,    89,
       0,     0,     0,    86,     0,   146,   147,   151,   259,     0,
       0,   148,     0,     0,     0,    57,    58,    59,     0,     0,
       0,     0,    63,     0,     0,   135,   137,     0,   148,   124,
       0,     0,     0,   127,     0,     0,   110,   114,     0,   112,
       0,   136,    86,     0,    46,    85,    44,     0,   149,     0,
      48,     0,   152,   260,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    62,    64,    86,    86,
       0,   134,     0,     0,     0,   115,     0,   111,   128,   126,
     113,   136,   148,     0,   136,     0,   181,   150,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   138,   133,     0,    86,   118,     0,     0,    86,   117,
     148,     0,   136,   148,    47,    55,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   139,   140,     0,     0,   116,
       0,     0,     0,   132,   148,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   119,     0,   120,     0,   131,     0,
     130,    41,   121,   122,   129
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    77,    78,    79,   371,   372,    80,    81,   108,   109,
     176,   128,   110,   129,   266,    83,    84,   481,   482,    85,
     164,    86,   237,   341,   342,   405,   406,   407,   493,   447,
     448,   494,   408,    87,   441,   485,   486,   409,    89,   420,
      90,    91,   181,   182,    92,    93,    94
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -434
static const yytype_int16 yypact[] =
{
    4146,  -105,    11,  4796,    -2,  4420,  4420,  4796,  -434,   -92,
     -89,   -39,   -93,   -30,   -23,   -20,  -434,  -434,  4796,  4796,
    4796,  4796,  -434,    87,    38,  -434,   120,    38,    62,   126,
      21,    31,  -434,  4796,  4796,  4796,  4796,  4796,  4796,  4796,
    4796,  4796,  4796,  4796,   143,  4796,  4420,  4420,  4420,  4796,
    4796,  4796,  4796,  4796,  4796,  -434,  -434,    67,  -434,  -434,
    -434,  4796,   -70,  -434,  -434,  -434,    71,  -434,    47,  -434,
      66,  4796,  4796,  4796,  4796,  4420,  4546,   832,  -434,  -434,
    -434,  -434,  -434,    86,  -434,  -434,  -434,  -434,    17,  -434,
    -434,  -434,  6561,  -434,  -434,  -434,   188,   188,    68,   216,
     140,  7926,   144,  -434,   154,  4796,   -60,  3729,  -434,   242,
    -434,   252,  6653,  4796,  4796,  4796,   123,  4796,  4796,  -434,
    -434,  -434,  4985,  5075,   170,   170,   -40,  -434,   131,  4283,
     152,   161,   151,   106,   185,  -434,   192,  4796,  -434,  4796,
     205,   205,  7926,  7926,   170,   170,   170,   170,   478,   170,
     170,   153,   174,   170,  -434,  -434,  -434,  7926,  7926,  7926,
    7926,  7926,  7926,  -434,   141,  7926,  -434,  4796,  -434,  4796,
    4796,   170,   170,   170,   170,  -434,  3867,  -434,   -67,   -55,
    -434,   -59,  -434,  5259,   180,  -434,  -434,  -434,  -434,   175,
    -434,  -434,  -434,  4796,  4796,  4796,  4796,  4796,  4796,  4796,
    4796,  4796,  4796,  4796,  4796,  4796,  4796,  4796,  4796,  4796,
    4796,  4796,   214,   203,   165,  4796,  4796,  -434,  4796,  4796,
    4796,  4796,  4796,  4796,  4796,  4796,  4796,  4796,  4796,  4796,
    4796,  4796,  4796,  4796,  4796,  -434,    51,   136,   145,   178,
    -434,  -434,   179,  7926,  4796,  -434,  4005,   186,   190,  -434,
    5352,  5445,   191,  4796,   195,   196,  4796,   194,   200,  4796,
    4796,  4796,   206,   209,   210,  -434,  -434,  4796,  4796,  4796,
      96,  -434,  -434,  -434,   198,  5538,  4796,  4796,  -434,   211,
     231,  5631,  -434,  -434,  -434,  4796,  4796,    49,  -434,  -434,
    4796,  4796,  8016,  8016,  8016,  8016,  8016,  8016,  8016,  8016,
    8016,  8016,  8170,  8170,   478,   478,   478,   478,   478,   478,
     478,  -434,  -434,  -434,  -434,  -434,  -434,  -434,   121,   121,
    8016,  8052,  7296,   635,   635,   635,   478,   478,    54,    54,
     158,   170,   170,  7205,  5165,  -434,   232,   184,   201,  -434,
    -434,   233,  -434,   -16,  -434,   -13,  -434,  -434,   236,  -434,
    4796,  4796,  4420,  4420,  4796,   254,   348,   348,  4895,  4796,
    4796,   255,   256,  5724,  4796,  4796,  4796,  6745,  6837,  5817,
    -434,     2,  -434,  -434,  -434,  -434,  -434,   239,   257,   258,
      32,  -434,  -434,  8016,  8016,   280,   281,  -434,   180,  8016,
     262,  4796,  -434,  -434,  -434,  -434,  -434,  -434,  -434,    51,
     -52,   -21,   267,  4796,  -434,   -10,  -434,  -434,  -434,    37,
    -434,    -7,   266,  5910,   269,  -434,   365,   268,   348,   207,
     276,   276,   277,  6003,   273,   348,   348,  -434,  6096,  6189,
    6282,  -434,  -434,   383,  -434,  -434,   118,  -434,  -434,   213,
    -434,   348,   302,  8134,  -434,   321,   166,  -434,   -85,   -50,
     -25,  4796,   284,  -434,  -434,  -434,  -434,   288,  4796,  -434,
     290,  4420,  4420,  4796,   276,  -434,  -434,  -434,  -434,  4796,
    4420,   348,   276,   276,  4283,  -434,  -434,  -434,   293,  4671,
     312,   -18,  -434,   295,   296,   318,  -434,   276,   348,  -434,
     338,    24,   339,  -434,   -46,   340,  -434,  -434,   -28,  -434,
     300,   302,  4796,   301,  -434,  -434,  -434,   303,  -434,  6375,
    -434,   276,  -434,  -434,  -434,  4796,  4796,  4796,  4796,   332,
     336,   328,  4796,  4796,  7386,   969,  -434,  -434,  4796,  4796,
     213,  -434,   276,    22,  4796,  -434,    48,  -434,  -434,  -434,
    -434,   302,   348,   308,   302,  4420,  -434,  -434,  6468,  7476,
    7566,  7656,   337,   342,  1107,  7746,  7836,  1245,  1383,   311,
     317,  -434,  -434,  4796,  4796,  -434,  6929,  4796,  4796,  -434,
     348,   276,   302,   348,  -434,  -434,  1521,  1659,  1797,  1935,
    2073,  2211,  2349,  2487,  2625,  -434,  -434,  7021,   319,  -434,
    7113,   323,   276,  -434,   348,   276,  4283,  2763,  2901,  3039,
    3177,  3315,  3453,  3591,  -434,   325,  -434,   326,  -434,   276,
    -434,  -434,  -434,  -434,  -434
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -434,  -434,   384,  -245,  -434,    99,  -244,  -242,   228,    -5,
     -99,   444,     0,  -424,  -434,  -434,  -434,  -434,    -9,  -434,
      60,  -239,   376,  -434,    76,   137,  -291,  -253,  -349,   -19,
      84,    39,  -166,  -434,  -433,  -434,   -44,    27,   -86,  -353,
    -434,     4,  -434,   202,   162,   421,   -69
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -85
static const yytype_int16 yytable[] =
{
      82,   111,   190,   474,   421,     2,   116,   184,   246,   488,
     117,   400,   401,   188,   400,   401,   188,   400,   401,   188,
     400,   401,   188,   479,   480,   370,   373,    88,   374,    32,
     166,   375,    32,   163,   495,    32,    26,    95,    32,    28,
     166,   154,   155,   156,    22,   166,   188,   118,   113,   490,
     445,   114,   491,   490,   492,   285,   491,   496,   492,   258,
     287,     8,    32,   259,    22,   464,   188,   286,   542,    16,
     167,   490,   472,   473,   491,   177,   492,    82,   337,   338,
     244,   445,    32,   402,   288,   446,   402,   403,   487,   402,
     403,   497,   402,   403,   495,   537,   403,   102,   103,     2,
     260,   115,   104,   126,    88,   191,   192,   177,   570,   242,
      96,   573,   119,   540,   454,    97,   449,   499,   511,   120,
     454,   189,   121,   526,   265,   404,   370,   373,   410,   374,
      26,   453,   375,    28,   459,   532,   457,   127,   105,   594,
     458,   274,   563,   434,   534,   538,    55,    56,   385,   538,
     339,   596,   455,   386,   439,   340,    65,    66,   455,   479,
     480,   133,   564,   138,   565,   101,   535,   163,   567,   112,
     217,   139,   191,   192,   440,   252,   284,   254,   255,    66,
     122,   123,   124,   125,   228,   229,   230,   169,   568,   571,
     569,   231,   232,   233,   234,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   170,   153,   118,   191,
     192,   157,   158,   159,   160,   161,   162,   592,   388,   130,
     595,   191,   192,   165,   131,   134,   135,   279,   187,   280,
     136,   236,   239,   171,   172,   173,   174,   217,   183,   456,
     166,   609,   151,   270,   240,   456,   284,   152,   271,   226,
     227,   228,   229,   230,   241,   247,   -85,   -85,   231,   232,
     233,   234,   248,   253,   316,   490,   137,   243,   491,   317,
     492,   261,   267,   343,   217,   250,   251,   165,   344,   165,
     165,   268,   345,   395,   278,   272,   217,   346,   396,   229,
     230,   269,   273,   276,   336,   231,   232,   233,   234,   243,
     397,   275,   290,   175,   348,   398,   465,   231,   232,   233,
     234,   466,   483,   355,   277,   291,   315,   484,   260,   361,
     362,   217,   347,   190,   311,   312,   350,   313,   314,   165,
     351,   165,   281,   354,   359,   175,   378,   379,   356,   357,
     360,   376,   231,   232,   233,   234,   364,   415,   416,   365,
     366,   390,   399,   419,   380,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   381,   394,   436,   318,   319,   412,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   165,   418,   425,   426,
     437,   438,   285,   286,   283,   442,   165,   451,   440,   462,
     463,   414,   461,   107,   417,   165,   471,   469,   358,   478,
     424,   165,   165,   363,   439,   489,   558,   501,   502,   367,
     368,   369,   504,   515,   525,   528,   529,   530,   165,   165,
     533,   536,   445,   541,   544,   552,   545,   383,   384,   553,
     554,   572,   389,   165,   585,   581,   505,   506,   584,   579,
     586,   186,   605,   452,   580,   510,   607,   612,   613,   514,
     435,   132,   527,   238,   283,   444,   539,   597,   598,   599,
     600,   601,   411,   602,   603,   450,   561,   168,   498,   387,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   500,   413,   165,     0,     0,   165,     0,   503,     0,
       0,   423,   165,   507,     0,   177,   428,   429,   430,   191,
     192,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     574,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   443,   177,     0,     0,   177,   284,   214,
     215,   216,   543,     0,     0,   165,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   177,   177,   177,   177,
     177,   284,   177,   177,   284,     0,     0,     0,   559,   560,
       0,   611,     0,     0,   217,     0,     0,   284,   284,   284,
     284,   284,   284,   284,     0,     0,   226,   227,   228,   229,
     230,     0,     0,   165,     0,   231,   232,   233,   234,     0,
     165,     0,     0,     0,   588,   165,     0,     0,   591,     0,
       0,   509,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   524,     0,     0,     0,     0,     0,     0,   467,   468,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   165,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   548,   549,   550,
     551,     0,     0,     0,   555,   556,   191,   192,     0,     0,
     165,   165,   508,     0,     0,     0,   566,     0,     0,     0,
     512,   513,     0,     0,     0,     0,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   531,   214,   215,   216,     0,
       0,     0,     0,     0,     0,   587,   165,     0,     0,   590,
     165,     0,     0,     0,     0,     0,     0,     0,     0,   547,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   217,     0,   175,     0,     0,     0,     0,     0,     0,
     562,   224,   225,   226,   227,   228,   229,   230,     0,     0,
       0,     0,   231,   232,   233,   234,     0,     0,     0,     0,
       0,     0,   175,     0,     0,   175,   283,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   593,
       0,     0,     0,     0,   175,   175,   175,   175,   175,   283,
     175,   175,   283,     0,     0,     0,     0,     0,     0,     0,
     608,     0,     0,   610,     0,   283,   283,   283,   283,   283,
     283,   283,   185,     1,     0,     2,     3,   614,     4,     5,
       6,     7,     0,     0,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,     0,    20,    21,    22,
       0,    23,    24,     0,     0,    25,    26,    27,     0,    28,
      29,    30,    31,     0,     0,     0,     0,    32,     0,     0,
       0,     0,     0,    33,    34,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    35,    36,    37,    38,    39,
      40,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    41,     0,     0,     0,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,     0,     0,    68,     0,     0,    69,     0,    70,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    71,     0,     0,     0,     0,    72,    73,    74,    75,
       1,     0,    76,     3,     0,     4,     5,     6,     7,     0,
       0,     8,     9,    10,    11,    98,    13,    14,    15,    16,
      17,    18,    19,     0,    20,    21,     0,     0,    99,    24,
       0,     0,    25,     0,    27,     0,     0,    29,    30,    31,
     -84,   -84,     0,     0,     0,     0,     0,     0,     0,     0,
      33,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,   106,    63,    64,    65,    66,    67,     0,
       0,    68,     0,     0,    69,     0,    70,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    71,     0,
       0,     0,     0,    72,    73,    74,   107,     0,     1,    76,
     -84,     3,     0,     4,     5,     6,     7,     0,     0,     8,
       9,    10,    11,    98,    13,    14,    15,    16,    17,    18,
      19,     0,    20,    21,     0,     0,    99,    24,     0,     0,
      25,     0,    27,     0,     0,    29,    30,    31,   -80,   -80,
       0,     0,     0,     0,     0,     0,     0,     0,    33,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    36,    37,    38,    39,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,   106,    63,    64,    65,    66,    67,     0,     0,    68,
       0,     0,    69,     0,    70,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    71,     0,     0,     0,
       0,    72,    73,    74,   107,     0,     1,    76,   -80,     3,
       0,     4,     5,     6,     7,     0,     0,     8,     9,    10,
      11,    98,    13,    14,    15,    16,    17,    18,    19,     0,
      20,    21,     0,     0,    99,    24,     0,     0,    25,     0,
      27,     0,     0,    29,    30,    31,   -82,   -82,     0,     0,
       0,     0,     0,     0,     0,     0,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    41,     0,     0,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,   106,
      63,    64,    65,    66,    67,     0,     0,    68,     0,     0,
      69,     0,    70,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    71,     0,     0,     0,     0,    72,
      73,    74,   107,     0,     1,    76,   -82,     3,     0,     4,
       5,     6,     7,     0,     0,     8,     9,    10,    11,    98,
      13,    14,    15,    16,    17,    18,    19,     0,    20,    21,
       0,     0,    99,    24,     0,     0,    25,     0,    27,     0,
       0,    29,    30,    31,   -83,   -83,     0,     0,     0,     0,
       0,     0,     0,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,   106,    63,    64,
      65,    66,    67,     0,     0,    68,     0,     0,    69,     0,
      70,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    71,     0,     0,     0,     0,    72,    73,    74,
     107,     0,     1,    76,   -83,     3,     0,     4,     5,     6,
       7,     0,     0,     8,     9,    10,    11,    98,    13,    14,
      15,    16,    17,    18,    19,     0,    20,    21,     0,     0,
      99,    24,     0,     0,    25,     0,    27,     0,     0,    29,
      30,    31,   -70,   -70,     0,     0,     0,     0,     0,     0,
       0,     0,    33,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,     0,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,   106,    63,    64,    65,    66,
      67,     0,     0,    68,     0,     0,    69,     0,    70,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      71,     0,     0,     0,     0,    72,    73,    74,   107,     0,
       1,    76,   -70,     3,     0,     4,     5,     6,     7,     0,
       0,     8,     9,    10,    11,    98,    13,    14,    15,    16,
      17,    18,    19,     0,    20,    21,     0,     0,    99,    24,
       0,     0,    25,     0,    27,     0,     0,    29,    30,    31,
     -68,   -68,     0,     0,     0,     0,     0,     0,     0,     0,
      33,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,   106,    63,    64,    65,    66,    67,     0,
       0,    68,     0,     0,    69,     0,    70,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    71,     0,
       0,     0,     0,    72,    73,    74,   107,     0,     1,    76,
     -68,     3,     0,     4,     5,     6,     7,     0,     0,     8,
       9,    10,    11,    98,    13,    14,    15,    16,    17,    18,
      19,     0,    20,    21,     0,     0,    99,    24,     0,     0,
      25,     0,    27,     0,     0,    29,    30,    31,   -66,   -66,
       0,     0,     0,     0,     0,     0,     0,     0,    33,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    36,    37,    38,    39,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,   106,    63,    64,    65,    66,    67,     0,     0,    68,
       0,     0,    69,     0,    70,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    71,     0,     0,     0,
       0,    72,    73,    74,   107,     0,     1,    76,   -66,     3,
       0,     4,     5,     6,     7,     0,     0,     8,     9,    10,
      11,    98,    13,    14,    15,    16,    17,    18,    19,     0,
      20,    21,     0,     0,    99,    24,     0,     0,    25,     0,
      27,     0,     0,    29,    30,    31,   -76,   -76,     0,     0,
       0,     0,     0,     0,     0,     0,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    41,     0,     0,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,   106,
      63,    64,    65,    66,    67,     0,     0,    68,     0,     0,
      69,     0,    70,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    71,     0,     0,     0,     0,    72,
      73,    74,   107,     0,     1,    76,   -76,     3,     0,     4,
       5,     6,     7,     0,     0,     8,     9,    10,    11,    98,
      13,    14,    15,    16,    17,    18,    19,     0,    20,    21,
       0,     0,    99,    24,     0,     0,    25,     0,    27,     0,
       0,    29,    30,    31,   -78,   -78,     0,     0,     0,     0,
       0,     0,     0,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,   106,    63,    64,
      65,    66,    67,     0,     0,    68,     0,     0,    69,     0,
      70,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    71,     0,     0,     0,     0,    72,    73,    74,
     107,     0,     1,    76,   -78,     3,     0,     4,     5,     6,
       7,     0,     0,     8,     9,    10,    11,    98,    13,    14,
      15,    16,    17,    18,    19,     0,    20,    21,     0,     0,
      99,    24,     0,     0,    25,     0,    27,     0,     0,    29,
      30,    31,   -79,   -79,     0,     0,     0,     0,     0,     0,
       0,     0,    33,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,     0,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,   106,    63,    64,    65,    66,
      67,     0,     0,    68,     0,     0,    69,     0,    70,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      71,     0,     0,     0,     0,    72,    73,    74,   107,     0,
       1,    76,   -79,     3,     0,     4,     5,     6,     7,     0,
       0,     8,     9,    10,    11,    98,    13,    14,    15,    16,
      17,    18,    19,     0,    20,    21,     0,     0,    99,    24,
       0,     0,    25,     0,    27,     0,     0,    29,    30,    31,
     -72,   -72,     0,     0,     0,     0,     0,     0,     0,     0,
      33,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,   106,    63,    64,    65,    66,    67,     0,
       0,    68,     0,     0,    69,     0,    70,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    71,     0,
       0,     0,     0,    72,    73,    74,   107,     0,     1,    76,
     -72,     3,     0,     4,     5,     6,     7,     0,     0,     8,
       9,    10,    11,    98,    13,    14,    15,    16,    17,    18,
      19,     0,    20,    21,     0,     0,    99,    24,     0,     0,
      25,     0,    27,     0,     0,    29,    30,    31,   -74,   -74,
       0,     0,     0,     0,     0,     0,     0,     0,    33,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    36,    37,    38,    39,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,   106,    63,    64,    65,    66,    67,     0,     0,    68,
       0,     0,    69,     0,    70,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    71,     0,     0,     0,
       0,    72,    73,    74,   107,     0,     1,    76,   -74,     3,
       0,     4,     5,     6,     7,     0,     0,     8,     9,    10,
      11,    98,    13,    14,    15,    16,    17,    18,    19,     0,
      20,    21,     0,     0,    99,    24,     0,     0,    25,     0,
      27,     0,     0,    29,    30,    31,   -81,   -81,     0,     0,
       0,     0,     0,     0,     0,     0,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    41,     0,     0,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,   106,
      63,    64,    65,    66,    67,     0,     0,    68,     0,     0,
      69,     0,    70,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    71,     0,     0,     0,     0,    72,
      73,    74,   107,     0,     1,    76,   -81,     3,     0,     4,
       5,     6,     7,     0,     0,     8,     9,    10,    11,    98,
      13,    14,    15,    16,    17,    18,    19,     0,    20,    21,
       0,     0,    99,    24,     0,     0,    25,     0,    27,     0,
       0,    29,    30,    31,   -69,   -69,     0,     0,     0,     0,
       0,     0,     0,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,   106,    63,    64,
      65,    66,    67,     0,     0,    68,     0,     0,    69,     0,
      70,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    71,     0,     0,     0,     0,    72,    73,    74,
     107,     0,     1,    76,   -69,     3,     0,     4,     5,     6,
       7,     0,     0,     8,     9,    10,    11,    98,    13,    14,
      15,    16,    17,    18,    19,     0,    20,    21,     0,     0,
      99,    24,     0,     0,    25,     0,    27,     0,     0,    29,
      30,    31,   -67,   -67,     0,     0,     0,     0,     0,     0,
       0,     0,    33,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,     0,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,   106,    63,    64,    65,    66,
      67,     0,     0,    68,     0,     0,    69,     0,    70,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      71,     0,     0,     0,     0,    72,    73,    74,   107,     0,
       1,    76,   -67,     3,     0,     4,     5,     6,     7,     0,
       0,     8,     9,    10,    11,    98,    13,    14,    15,    16,
      17,    18,    19,     0,    20,    21,     0,     0,    99,    24,
       0,     0,    25,     0,    27,     0,     0,    29,    30,    31,
     -65,   -65,     0,     0,     0,     0,     0,     0,     0,     0,
      33,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,   106,    63,    64,    65,    66,    67,     0,
       0,    68,     0,     0,    69,     0,    70,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    71,     0,
       0,     0,     0,    72,    73,    74,   107,     0,     1,    76,
     -65,     3,     0,     4,     5,     6,     7,     0,     0,     8,
       9,    10,    11,    98,    13,    14,    15,    16,    17,    18,
      19,     0,    20,    21,     0,     0,    99,    24,     0,     0,
      25,     0,    27,     0,     0,    29,    30,    31,   -75,   -75,
       0,     0,     0,     0,     0,     0,     0,     0,    33,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    36,    37,    38,    39,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,   106,    63,    64,    65,    66,    67,     0,     0,    68,
       0,     0,    69,     0,    70,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    71,     0,     0,     0,
       0,    72,    73,    74,   107,     0,     1,    76,   -75,     3,
       0,     4,     5,     6,     7,     0,     0,     8,     9,    10,
      11,    98,    13,    14,    15,    16,    17,    18,    19,     0,
      20,    21,     0,     0,    99,    24,     0,     0,    25,     0,
      27,     0,     0,    29,    30,    31,   -77,   -77,     0,     0,
       0,     0,     0,     0,     0,     0,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    41,     0,     0,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,   106,
      63,    64,    65,    66,    67,     0,     0,    68,     0,     0,
      69,     0,    70,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    71,     0,     0,     0,     0,    72,
      73,    74,   107,     0,     1,    76,   -77,     3,     0,     4,
       5,     6,     7,     0,     0,     8,     9,    10,    11,    98,
      13,    14,    15,    16,    17,    18,    19,     0,    20,    21,
       0,     0,    99,    24,     0,     0,    25,     0,    27,     0,
       0,    29,    30,    31,   -71,   -71,     0,     0,     0,     0,
       0,     0,     0,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,   106,    63,    64,
      65,    66,    67,     0,     0,    68,     0,     0,    69,     0,
      70,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    71,     0,     0,     0,     0,    72,    73,    74,
     107,     0,     1,    76,   -71,     3,     0,     4,     5,     6,
       7,     0,     0,     8,     9,    10,    11,    98,    13,    14,
      15,    16,    17,    18,    19,     0,    20,    21,     0,     0,
      99,    24,     0,     0,    25,     0,    27,     0,     0,    29,
      30,    31,   -73,   -73,     0,     0,     0,     0,     0,     0,
       0,     0,    33,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,     0,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,   106,    63,    64,    65,    66,
      67,     0,     0,    68,     0,     0,    69,     0,    70,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      71,     0,     0,     0,     0,    72,    73,    74,   107,     0,
       1,    76,   -73,     3,     0,     4,     5,     6,     7,     0,
       0,     8,     9,    10,    11,    98,    13,    14,    15,    16,
      17,    18,    19,     0,    20,    21,     0,     0,    99,    24,
       0,     0,    25,     0,    27,     0,     0,    29,    30,    31,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      33,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,   106,    63,    64,    65,    66,    67,     0,
       0,    68,     0,     0,    69,     0,    70,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    71,     0,
       0,     0,     0,    72,    73,    74,   107,     0,     1,    76,
     245,     3,     0,     4,     5,     6,     7,     0,     0,     8,
       9,    10,    11,    98,    13,    14,    15,    16,    17,    18,
      19,     0,    20,    21,     0,     0,    99,    24,     0,     0,
      25,     0,    27,     0,     0,    29,    30,    31,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    33,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    36,    37,    38,    39,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,   106,    63,    64,    65,    66,    67,     0,     0,    68,
       0,     0,    69,     0,    70,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    71,     0,     0,     0,
       0,    72,    73,    74,   107,     0,     1,    76,   282,     3,
       0,     4,     5,     6,     7,     0,     0,     8,     9,    10,
      11,    98,    13,    14,    15,    16,    17,    18,    19,     0,
      20,    21,     0,     0,    99,    24,     0,     0,    25,     0,
      27,     0,     0,    29,    30,    31,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    41,     0,     0,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,   106,
      63,    64,    65,    66,    67,     0,     0,    68,     0,     0,
      69,     0,    70,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    71,     0,     0,     0,     0,    72,
      73,    74,   107,     0,     0,    76,   349,     1,     0,     2,
       3,     0,     4,     5,     6,     7,     0,     0,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
       0,    20,    21,    22,     0,    23,    24,     0,     0,    25,
      26,    27,     0,    28,    29,    30,    31,     0,     0,     0,
       0,    32,     0,     0,     0,     0,     0,    33,    34,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    35,
      36,    37,    38,    39,    40,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    41,     0,     0,     0,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,     0,     0,    68,     0,
       0,    69,     0,    70,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    71,     0,     0,     0,     0,
      72,    73,    74,    75,     1,     0,    76,     3,     0,     4,
       5,     6,     7,     0,   262,     8,     9,    10,    11,    98,
      13,    14,    15,    16,    17,    18,    19,     0,    20,    21,
       0,     0,    99,    24,   263,   264,    25,     0,    27,     0,
       0,    29,    30,    31,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,   106,    63,    64,
      65,    66,    67,     0,     0,    68,     0,     0,    69,     0,
      70,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    71,     0,     0,     0,     0,    72,    73,    74,
     107,     1,     0,    76,     3,     0,     4,     5,     6,     7,
       0,     0,     8,     9,    10,    11,    98,    13,    14,    15,
      16,    17,    18,    19,     0,    20,    21,     0,     0,    99,
      24,     0,     0,    25,     0,    27,     0,     0,    29,    30,
      31,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    33,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    35,    36,    37,    38,    39,    40,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      41,     0,     0,     0,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,   106,    63,    64,    65,    66,    67,
       0,     0,    68,     0,     0,    69,     0,    70,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    71,
       0,     0,     4,     0,    72,    73,    74,   107,     8,     0,
      76,     0,    98,     0,     0,     0,    16,    17,    18,     0,
       0,    20,    21,     0,     0,    99,     0,     0,     0,     0,
       0,     0,     0,     0,    29,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    33,    34,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    35,
      36,    37,    38,    39,    40,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    41,     0,     0,     0,
      42,    43,    44,    45,     0,     0,     0,    49,    50,    51,
      52,    53,    54,    55,    56,   178,    58,    59,    60,    61,
     179,    63,    64,    65,    66,    67,     0,     0,    68,     0,
       0,    69,     0,    70,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    71,     0,     4,     0,     0,
      72,    73,    74,     8,     0,     0,    76,    98,     0,   180,
       0,    16,    17,    18,     0,     0,    20,    21,     0,     0,
      99,     0,     0,     0,     0,     0,     0,     0,     0,    29,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    33,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,   516,     0,   517,   518,     0,     0,     0,   519,
     520,    41,     0,     0,     0,    42,    43,    44,    45,     0,
       0,     0,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,   100,    63,    64,    65,    66,
      67,     0,     0,    68,   521,     0,    69,     0,    70,     0,
       0,     0,     0,     0,     0,     0,     0,   522,   523,     0,
      71,     0,     4,     0,     0,    72,    73,    74,     8,     0,
       0,    76,    98,     0,     0,     0,    16,    17,    18,     0,
       0,    20,    21,     0,     0,    99,     0,     0,     0,     0,
       0,     0,     0,     0,    29,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    33,    34,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    35,
      36,    37,    38,    39,    40,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    41,     0,     0,     0,
      42,    43,    44,    45,     0,     0,     0,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
     100,    63,    64,    65,    66,    67,   422,     0,    68,     0,
       0,    69,     0,    70,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    71,     0,     0,     0,     0,
      72,    73,    74,     0,     0,     0,    76,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,     0,     0,
       0,     0,     0,     0,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,     0,   214,   215,   216,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   256,
       0,   217,     0,     0,   218,   219,   220,     0,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,     0,     0,
       0,     0,   231,   232,   233,   234,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,     0,     0,
       0,     0,     0,     0,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,     0,   214,   215,   216,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   257,
       0,   217,     0,     0,   218,   219,   220,     0,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,     0,     0,
       0,     0,   231,   232,   233,   234,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,     0,     0,
       0,     0,     0,     0,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,     0,   214,   215,   216,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   217,     0,     0,   218,   219,   220,     0,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,     0,     0,
       0,     0,   231,   232,   233,   234,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,     0,     0,
       0,     0,     0,     0,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,     0,   214,   215,   216,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   217,     0,     0,   218,   219,   220,     0,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,     0,     0,
       0,     0,   231,   232,   233,   234,     0,     0,     0,   393,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,     0,     0,     0,     0,     0,     0,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,     0,
     214,   215,   216,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   217,     0,     0,   218,   219,
     220,     0,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,     0,     0,     0,     0,   231,   232,   233,   234,
       0,     0,   289,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,     0,     0,     0,     0,     0,
       0,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,     0,   214,   215,   216,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   217,     0,
       0,   218,   219,   220,     0,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,     0,     0,     0,     0,   231,
     232,   233,   234,     0,     0,   352,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,     0,     0,
       0,     0,     0,     0,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,     0,   214,   215,   216,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   217,     0,     0,   218,   219,   220,     0,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,     0,     0,
       0,     0,   231,   232,   233,   234,     0,     0,   353,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,     0,     0,     0,     0,     0,     0,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,     0,   214,
     215,   216,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   217,     0,     0,   218,   219,   220,
       0,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,     0,     0,     0,     0,   231,   232,   233,   234,     0,
       0,   377,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,     0,     0,     0,     0,     0,     0,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,     0,   214,   215,   216,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   217,     0,     0,
     218,   219,   220,     0,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,     0,     0,     0,     0,   231,   232,
     233,   234,     0,     0,   382,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,     0,     0,     0,
       0,     0,     0,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,     0,   214,   215,   216,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     217,     0,     0,   218,   219,   220,     0,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,     0,     0,     0,
       0,   231,   232,   233,   234,     0,     0,   427,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
       0,     0,     0,     0,     0,     0,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,     0,   214,   215,
     216,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   217,     0,     0,   218,   219,   220,     0,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
       0,     0,     0,     0,   231,   232,   233,   234,     0,     0,
     433,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,     0,     0,     0,     0,     0,     0,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
       0,   214,   215,   216,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   217,     0,     0,   218,
     219,   220,     0,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,     0,     0,     0,     0,   231,   232,   233,
     234,     0,     0,   460,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,     0,     0,     0,     0,
       0,     0,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,     0,   214,   215,   216,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   217,
       0,     0,   218,   219,   220,     0,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,     0,     0,     0,     0,
     231,   232,   233,   234,     0,     0,   470,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,     0,
       0,     0,     0,     0,     0,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,     0,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,     0,     0,   218,   219,   220,     0,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,     0,
       0,     0,     0,   231,   232,   233,   234,     0,     0,   475,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,     0,     0,     0,     0,     0,     0,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,     0,
     214,   215,   216,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   217,     0,     0,   218,   219,
     220,     0,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,     0,     0,     0,     0,   231,   232,   233,   234,
       0,     0,   476,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,     0,     0,     0,     0,     0,
       0,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,     0,   214,   215,   216,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   217,     0,
       0,   218,   219,   220,     0,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,     0,     0,     0,     0,   231,
     232,   233,   234,     0,     0,   477,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,     0,     0,
       0,     0,     0,     0,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,     0,   214,   215,   216,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   217,     0,     0,   218,   219,   220,     0,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,     0,     0,
       0,     0,   231,   232,   233,   234,     0,     0,   546,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,     0,     0,     0,     0,     0,     0,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,     0,   214,
     215,   216,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   217,     0,     0,   218,   219,   220,
       0,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,     0,     0,     0,     0,   231,   232,   233,   234,     0,
       0,   575,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,     0,     0,     0,     0,     0,     0,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,     0,   214,   215,   216,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   217,     0,     0,
     218,   219,   220,     0,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,     0,     0,     0,     0,   231,   232,
     233,   234,     0,   235,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,     0,     0,     0,     0,
       0,     0,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,     0,   214,   215,   216,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   217,
       0,     0,   218,   219,   220,     0,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,     0,     0,     0,     0,
     231,   232,   233,   234,     0,   249,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,     0,     0,
       0,     0,     0,     0,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,     0,   214,   215,   216,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   217,     0,     0,   218,   219,   220,     0,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,     0,     0,
       0,     0,   231,   232,   233,   234,     0,   431,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
       0,     0,     0,     0,     0,     0,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,     0,   214,   215,
     216,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   217,     0,     0,   218,   219,   220,     0,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
       0,     0,     0,     0,   231,   232,   233,   234,     0,   432,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,     0,     0,     0,     0,     0,     0,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,     0,
     214,   215,   216,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   217,     0,     0,   218,   219,
     220,     0,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,     0,     0,     0,     0,   231,   232,   233,   234,
       0,   589,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,     0,     0,     0,     0,     0,     0,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,     0,   214,   215,   216,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   217,     0,     0,
     218,   219,   220,     0,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,     0,     0,     0,     0,   231,   232,
     233,   234,     0,   604,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,     0,     0,     0,     0,
       0,     0,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,     0,   214,   215,   216,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   217,
       0,     0,   218,   219,   220,     0,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,     0,     0,     0,     0,
     231,   232,   233,   234,     0,   606,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,     0,     0,
       0,     0,     0,     0,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,     0,   214,   215,   216,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   217,     0,     0,   218,   219,   220,     0,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,     0,     0,
       0,     0,   231,   232,   233,   234,   392,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,     0,
       0,     0,     0,     0,     0,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,     0,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,     0,     0,   218,   219,   220,   391,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,     0,
       0,     0,     0,   231,   232,   233,   234,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,     0,
       0,     0,     0,     0,     0,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,     0,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,     0,     0,   218,   219,   220,   557,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,     0,
       0,     0,     0,   231,   232,   233,   234,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,     0,
       0,     0,     0,     0,     0,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,     0,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,     0,     0,   218,   219,   220,   576,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,     0,
       0,     0,     0,   231,   232,   233,   234,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,     0,
       0,     0,     0,     0,     0,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,     0,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,     0,     0,   218,   219,   220,   577,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,     0,
       0,     0,     0,   231,   232,   233,   234,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,     0,
       0,     0,     0,     0,     0,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,     0,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,     0,     0,   218,   219,   220,   578,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,     0,
       0,     0,     0,   231,   232,   233,   234,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,     0,
       0,     0,     0,     0,     0,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,     0,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,     0,     0,   218,   219,   220,   582,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,     0,
       0,     0,     0,   231,   232,   233,   234,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,     0,
       0,     0,     0,     0,     0,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,     0,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,     0,     0,   218,   219,   220,   583,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,     0,
       0,     0,     0,   231,   232,   233,   234,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,     0,
       0,     0,     0,     0,     0,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,     0,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,     0,     0,   218,   219,   220,     0,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,     0,
       0,     0,     0,   231,   232,   233,   234,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,     0,
       0,     0,     0,     0,     0,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,     0,   214,   215,   216,
       0,     0,     0,   191,   192,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   217,   214,   215,   216,   219,   220,     0,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,     0,
       0,     0,     0,   231,   232,   233,   234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   217,     0,
       0,     0,   219,   220,     0,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   191,   192,     0,     0,   231,
     232,   233,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,     0,   214,   215,   216,     0,     0,
       0,   191,   192,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     217,   214,   215,   216,     0,   220,     0,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,     0,     0,     0,
       0,   231,   232,   233,   234,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   217,     0,     0,     0,
       0,     0,     0,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,     0,     0,     0,     0,   231,   232,   233,
     234
};

static const yytype_int16 yycheck[] =
{
       0,     6,    88,   427,   357,     3,    99,    76,   107,   442,
     103,    27,    28,    29,    27,    28,    29,    27,    28,    29,
      27,    28,    29,    41,    42,   270,   270,     0,   270,    45,
     100,   270,    45,   100,   119,    45,    34,   142,    45,    37,
     100,    46,    47,    48,    27,   100,    29,   140,   140,    99,
     102,   140,   102,    99,   104,   122,   102,   142,   104,    99,
     119,    12,    45,   103,    27,   418,    29,   122,   501,    20,
     140,    99,   425,   426,   102,    75,   104,    77,    27,    28,
     140,   102,    45,    99,   143,   137,    99,   103,   441,    99,
     103,   141,    99,   103,   119,   141,   103,    99,   100,     3,
     140,   140,   104,    16,    77,    51,    52,   107,   541,   105,
      99,   544,   142,   141,   405,   104,   137,   142,   471,   142,
     411,   104,   142,   141,   129,   141,   371,   371,   141,   371,
      34,   141,   371,    37,   141,   488,    99,    99,   140,   572,
     103,   137,   120,   141,   120,   494,    97,    98,    99,   498,
      99,   575,   405,   104,   122,   104,   107,   108,   411,    41,
      42,    99,   140,   142,   142,     3,   142,   100,   120,     7,
     116,   140,    51,    52,   142,   115,   176,   117,   118,   108,
      18,    19,    20,    21,   130,   131,   132,   140,   140,   542,
     142,   137,   138,   139,   140,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,   140,    45,   140,    51,
      52,    49,    50,    51,    52,    53,    54,   570,   287,    99,
     573,    51,    52,    61,   104,    99,   100,   167,   142,   169,
     104,    43,    16,    71,    72,    73,    74,   116,    76,   405,
     100,   594,    99,   137,   100,   411,   246,   104,   142,   128,
     129,   130,   131,   132,   100,    13,    51,    52,   137,   138,
     139,   140,    10,   140,    99,    99,   140,   105,   102,   104,
     104,   140,   120,   137,   116,   113,   114,   115,   142,   117,
     118,   120,   137,    99,   143,   100,   116,   142,   104,   131,
     132,   140,   100,   140,   234,   137,   138,   139,   140,   137,
      99,   139,   122,    75,   244,   104,    99,   137,   138,   139,
     140,   104,    99,   253,   140,   140,   113,   104,   140,   259,
     260,   116,   143,   409,   110,   111,   140,   113,   114,   167,
     140,   169,   170,   142,   140,   107,   276,   277,   143,   143,
     140,   143,   137,   138,   139,   140,   140,   352,   353,   140,
     140,   291,   119,     5,   143,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   143,   143,   137,   215,   216,   143,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   143,   143,   143,
     143,   143,   122,   122,   176,   143,   244,   140,   142,    44,
     142,   351,   143,   137,   354,   253,   143,   140,   256,    36,
     360,   259,   260,   261,   122,   104,   525,   143,   140,   267,
     268,   269,   142,   140,   122,   140,   140,   119,   276,   277,
     102,   102,   102,   143,   143,   113,   143,   285,   286,   113,
     122,   143,   290,   291,   143,   554,   461,   462,   557,   122,
     143,    77,   143,   403,   122,   470,   143,   142,   142,   474,
     371,    27,   481,    97,   246,   399,   495,   576,   577,   578,
     579,   580,   345,   582,   583,   401,   530,    66,   449,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   451,   350,   351,    -1,    -1,   354,    -1,   458,    -1,
      -1,   359,   360,   463,    -1,   525,   364,   365,   366,    51,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     545,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   391,   554,    -1,    -1,   557,   558,    81,
      82,    83,   502,    -1,    -1,   403,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   576,   577,   578,   579,
     580,   581,   582,   583,   584,    -1,    -1,    -1,   528,   529,
      -1,   596,    -1,    -1,   116,    -1,    -1,   597,   598,   599,
     600,   601,   602,   603,    -1,    -1,   128,   129,   130,   131,
     132,    -1,    -1,   451,    -1,   137,   138,   139,   140,    -1,
     458,    -1,    -1,    -1,   564,   463,    -1,    -1,   568,    -1,
      -1,   469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   479,    -1,    -1,    -1,    -1,    -1,    -1,   420,   421,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,   516,   517,
     518,    -1,    -1,    -1,   522,   523,    51,    52,    -1,    -1,
     528,   529,   464,    -1,    -1,    -1,   534,    -1,    -1,    -1,
     472,   473,    -1,    -1,    -1,    -1,    71,    72,    73,    74,
      75,    76,    77,    78,    79,   487,    81,    82,    83,    -1,
      -1,    -1,    -1,    -1,    -1,   563,   564,    -1,    -1,   567,
     568,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   511,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,    -1,   525,    -1,    -1,    -1,    -1,    -1,    -1,
     532,   126,   127,   128,   129,   130,   131,   132,    -1,    -1,
      -1,    -1,   137,   138,   139,   140,    -1,    -1,    -1,    -1,
      -1,    -1,   554,    -1,    -1,   557,   558,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   571,
      -1,    -1,    -1,    -1,   576,   577,   578,   579,   580,   581,
     582,   583,   584,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     592,    -1,    -1,   595,    -1,   597,   598,   599,   600,   601,
     602,   603,     0,     1,    -1,     3,     4,   609,     6,     7,
       8,     9,    -1,    -1,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    29,    30,    -1,    -1,    33,    34,    35,    -1,    37,
      38,    39,    40,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    -1,    -1,    51,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    64,    65,    66,    67,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    80,    -1,    -1,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,    -1,    -1,   112,    -1,    -1,   115,    -1,   117,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   129,    -1,    -1,    -1,    -1,   134,   135,   136,   137,
       1,    -1,   140,     4,    -1,     6,     7,     8,     9,    -1,
      -1,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    -1,    25,    26,    -1,    -1,    29,    30,
      -1,    -1,    33,    -1,    35,    -1,    -1,    38,    39,    40,
      41,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    64,    65,    66,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,    -1,
      -1,   112,    -1,    -1,   115,    -1,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,
      -1,    -1,    -1,   134,   135,   136,   137,    -1,     1,   140,
     141,     4,    -1,     6,     7,     8,     9,    -1,    -1,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    -1,    25,    26,    -1,    -1,    29,    30,    -1,    -1,
      33,    -1,    35,    -1,    -1,    38,    39,    40,    41,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    64,    65,    66,    67,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,    -1,    -1,   112,
      -1,    -1,   115,    -1,   117,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,
      -1,   134,   135,   136,   137,    -1,     1,   140,   141,     4,
      -1,     6,     7,     8,     9,    -1,    -1,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
      25,    26,    -1,    -1,    29,    30,    -1,    -1,    33,    -1,
      35,    -1,    -1,    38,    39,    40,    41,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    64,
      65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,    -1,    -1,   112,    -1,    -1,
     115,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,    -1,   134,
     135,   136,   137,    -1,     1,   140,   141,     4,    -1,     6,
       7,     8,     9,    -1,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    -1,    25,    26,
      -1,    -1,    29,    30,    -1,    -1,    33,    -1,    35,    -1,
      -1,    38,    39,    40,    41,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    66,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,    -1,    -1,   112,    -1,    -1,   115,    -1,
     117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   129,    -1,    -1,    -1,    -1,   134,   135,   136,
     137,    -1,     1,   140,   141,     4,    -1,     6,     7,     8,
       9,    -1,    -1,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    -1,    25,    26,    -1,    -1,
      29,    30,    -1,    -1,    33,    -1,    35,    -1,    -1,    38,
      39,    40,    41,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    63,    64,    65,    66,    67,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    80,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,    -1,    -1,   112,    -1,    -1,   115,    -1,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     129,    -1,    -1,    -1,    -1,   134,   135,   136,   137,    -1,
       1,   140,   141,     4,    -1,     6,     7,     8,     9,    -1,
      -1,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    -1,    25,    26,    -1,    -1,    29,    30,
      -1,    -1,    33,    -1,    35,    -1,    -1,    38,    39,    40,
      41,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    64,    65,    66,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,    -1,
      -1,   112,    -1,    -1,   115,    -1,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,
      -1,    -1,    -1,   134,   135,   136,   137,    -1,     1,   140,
     141,     4,    -1,     6,     7,     8,     9,    -1,    -1,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    -1,    25,    26,    -1,    -1,    29,    30,    -1,    -1,
      33,    -1,    35,    -1,    -1,    38,    39,    40,    41,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    64,    65,    66,    67,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,    -1,    -1,   112,
      -1,    -1,   115,    -1,   117,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,
      -1,   134,   135,   136,   137,    -1,     1,   140,   141,     4,
      -1,     6,     7,     8,     9,    -1,    -1,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
      25,    26,    -1,    -1,    29,    30,    -1,    -1,    33,    -1,
      35,    -1,    -1,    38,    39,    40,    41,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    64,
      65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,    -1,    -1,   112,    -1,    -1,
     115,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,    -1,   134,
     135,   136,   137,    -1,     1,   140,   141,     4,    -1,     6,
       7,     8,     9,    -1,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    -1,    25,    26,
      -1,    -1,    29,    30,    -1,    -1,    33,    -1,    35,    -1,
      -1,    38,    39,    40,    41,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    66,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,    -1,    -1,   112,    -1,    -1,   115,    -1,
     117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   129,    -1,    -1,    -1,    -1,   134,   135,   136,
     137,    -1,     1,   140,   141,     4,    -1,     6,     7,     8,
       9,    -1,    -1,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    -1,    25,    26,    -1,    -1,
      29,    30,    -1,    -1,    33,    -1,    35,    -1,    -1,    38,
      39,    40,    41,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    63,    64,    65,    66,    67,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    80,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,    -1,    -1,   112,    -1,    -1,   115,    -1,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     129,    -1,    -1,    -1,    -1,   134,   135,   136,   137,    -1,
       1,   140,   141,     4,    -1,     6,     7,     8,     9,    -1,
      -1,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    -1,    25,    26,    -1,    -1,    29,    30,
      -1,    -1,    33,    -1,    35,    -1,    -1,    38,    39,    40,
      41,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    64,    65,    66,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,    -1,
      -1,   112,    -1,    -1,   115,    -1,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,
      -1,    -1,    -1,   134,   135,   136,   137,    -1,     1,   140,
     141,     4,    -1,     6,     7,     8,     9,    -1,    -1,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    -1,    25,    26,    -1,    -1,    29,    30,    -1,    -1,
      33,    -1,    35,    -1,    -1,    38,    39,    40,    41,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    64,    65,    66,    67,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,    -1,    -1,   112,
      -1,    -1,   115,    -1,   117,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,
      -1,   134,   135,   136,   137,    -1,     1,   140,   141,     4,
      -1,     6,     7,     8,     9,    -1,    -1,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
      25,    26,    -1,    -1,    29,    30,    -1,    -1,    33,    -1,
      35,    -1,    -1,    38,    39,    40,    41,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    64,
      65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,    -1,    -1,   112,    -1,    -1,
     115,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,    -1,   134,
     135,   136,   137,    -1,     1,   140,   141,     4,    -1,     6,
       7,     8,     9,    -1,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    -1,    25,    26,
      -1,    -1,    29,    30,    -1,    -1,    33,    -1,    35,    -1,
      -1,    38,    39,    40,    41,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    66,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,    -1,    -1,   112,    -1,    -1,   115,    -1,
     117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   129,    -1,    -1,    -1,    -1,   134,   135,   136,
     137,    -1,     1,   140,   141,     4,    -1,     6,     7,     8,
       9,    -1,    -1,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    -1,    25,    26,    -1,    -1,
      29,    30,    -1,    -1,    33,    -1,    35,    -1,    -1,    38,
      39,    40,    41,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    63,    64,    65,    66,    67,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    80,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,    -1,    -1,   112,    -1,    -1,   115,    -1,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     129,    -1,    -1,    -1,    -1,   134,   135,   136,   137,    -1,
       1,   140,   141,     4,    -1,     6,     7,     8,     9,    -1,
      -1,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    -1,    25,    26,    -1,    -1,    29,    30,
      -1,    -1,    33,    -1,    35,    -1,    -1,    38,    39,    40,
      41,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    64,    65,    66,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,    -1,
      -1,   112,    -1,    -1,   115,    -1,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,
      -1,    -1,    -1,   134,   135,   136,   137,    -1,     1,   140,
     141,     4,    -1,     6,     7,     8,     9,    -1,    -1,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    -1,    25,    26,    -1,    -1,    29,    30,    -1,    -1,
      33,    -1,    35,    -1,    -1,    38,    39,    40,    41,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    64,    65,    66,    67,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,    -1,    -1,   112,
      -1,    -1,   115,    -1,   117,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,
      -1,   134,   135,   136,   137,    -1,     1,   140,   141,     4,
      -1,     6,     7,     8,     9,    -1,    -1,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
      25,    26,    -1,    -1,    29,    30,    -1,    -1,    33,    -1,
      35,    -1,    -1,    38,    39,    40,    41,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    64,
      65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,    -1,    -1,   112,    -1,    -1,
     115,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,    -1,   134,
     135,   136,   137,    -1,     1,   140,   141,     4,    -1,     6,
       7,     8,     9,    -1,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    -1,    25,    26,
      -1,    -1,    29,    30,    -1,    -1,    33,    -1,    35,    -1,
      -1,    38,    39,    40,    41,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    66,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,    -1,    -1,   112,    -1,    -1,   115,    -1,
     117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   129,    -1,    -1,    -1,    -1,   134,   135,   136,
     137,    -1,     1,   140,   141,     4,    -1,     6,     7,     8,
       9,    -1,    -1,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    -1,    25,    26,    -1,    -1,
      29,    30,    -1,    -1,    33,    -1,    35,    -1,    -1,    38,
      39,    40,    41,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    63,    64,    65,    66,    67,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    80,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,    -1,    -1,   112,    -1,    -1,   115,    -1,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     129,    -1,    -1,    -1,    -1,   134,   135,   136,   137,    -1,
       1,   140,   141,     4,    -1,     6,     7,     8,     9,    -1,
      -1,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    -1,    25,    26,    -1,    -1,    29,    30,
      -1,    -1,    33,    -1,    35,    -1,    -1,    38,    39,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    64,    65,    66,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,    -1,
      -1,   112,    -1,    -1,   115,    -1,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,
      -1,    -1,    -1,   134,   135,   136,   137,    -1,     1,   140,
     141,     4,    -1,     6,     7,     8,     9,    -1,    -1,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    -1,    25,    26,    -1,    -1,    29,    30,    -1,    -1,
      33,    -1,    35,    -1,    -1,    38,    39,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    64,    65,    66,    67,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,    -1,    -1,   112,
      -1,    -1,   115,    -1,   117,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,
      -1,   134,   135,   136,   137,    -1,     1,   140,   141,     4,
      -1,     6,     7,     8,     9,    -1,    -1,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
      25,    26,    -1,    -1,    29,    30,    -1,    -1,    33,    -1,
      35,    -1,    -1,    38,    39,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    64,
      65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,    -1,    -1,   112,    -1,    -1,
     115,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,    -1,   134,
     135,   136,   137,    -1,    -1,   140,   141,     1,    -1,     3,
       4,    -1,     6,     7,     8,     9,    -1,    -1,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    29,    30,    -1,    -1,    33,
      34,    35,    -1,    37,    38,    39,    40,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    -1,    51,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      64,    65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,    -1,    -1,   112,    -1,
      -1,   115,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,    -1,
     134,   135,   136,   137,     1,    -1,   140,     4,    -1,     6,
       7,     8,     9,    -1,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    -1,    25,    26,
      -1,    -1,    29,    30,    31,    32,    33,    -1,    35,    -1,
      -1,    38,    39,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    66,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,    -1,    -1,   112,    -1,    -1,   115,    -1,
     117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   129,    -1,    -1,    -1,    -1,   134,   135,   136,
     137,     1,    -1,   140,     4,    -1,     6,     7,     8,     9,
      -1,    -1,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    -1,    -1,    29,
      30,    -1,    -1,    33,    -1,    35,    -1,    -1,    38,    39,
      40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    64,    65,    66,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
      -1,    -1,   112,    -1,    -1,   115,    -1,   117,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,
      -1,    -1,     6,    -1,   134,   135,   136,   137,    12,    -1,
     140,    -1,    16,    -1,    -1,    -1,    20,    21,    22,    -1,
      -1,    25,    26,    -1,    -1,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      64,    65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,    -1,    -1,   112,    -1,
      -1,   115,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   129,    -1,     6,    -1,    -1,
     134,   135,   136,    12,    -1,    -1,   140,    16,    -1,   143,
      -1,    20,    21,    22,    -1,    -1,    25,    26,    -1,    -1,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    63,    64,    65,    66,    67,    68,
      -1,    -1,    71,    -1,    73,    74,    -1,    -1,    -1,    78,
      79,    80,    -1,    -1,    -1,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,    -1,    -1,   112,   113,    -1,   115,    -1,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   126,   127,    -1,
     129,    -1,     6,    -1,    -1,   134,   135,   136,    12,    -1,
      -1,   140,    16,    -1,    -1,    -1,    20,    21,    22,    -1,
      -1,    25,    26,    -1,    -1,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      64,    65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,    11,    -1,   112,    -1,
      -1,   115,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,    -1,
     134,   135,   136,    -1,    -1,    -1,   140,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    -1,    81,    82,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,    -1,
      -1,    -1,   137,   138,   139,   140,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    -1,    81,    82,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,    -1,
      -1,    -1,   137,   138,   139,   140,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    -1,    81,    82,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,    -1,
      -1,    -1,   137,   138,   139,   140,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    -1,    81,    82,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,    -1,
      -1,    -1,   137,   138,   139,   140,    -1,    -1,    -1,   144,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    -1,
      81,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,    -1,    -1,    -1,    -1,   137,   138,   139,   140,
      -1,    -1,   143,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    -1,    81,    82,    83,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,
      -1,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,    -1,    -1,    -1,   137,
     138,   139,   140,    -1,    -1,   143,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    -1,    81,    82,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,    -1,
      -1,    -1,   137,   138,   139,   140,    -1,    -1,   143,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    -1,    81,
      82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   116,    -1,    -1,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    -1,    -1,    -1,    -1,   137,   138,   139,   140,    -1,
      -1,   143,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    -1,    81,    82,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,    -1,    -1,    -1,    -1,   137,   138,
     139,   140,    -1,    -1,   143,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    -1,    -1,    -1,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    -1,    81,    82,    83,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     116,    -1,    -1,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,    -1,    -1,
      -1,   137,   138,   139,   140,    -1,    -1,   143,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    -1,    81,    82,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   116,    -1,    -1,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
      -1,    -1,    -1,    -1,   137,   138,   139,   140,    -1,    -1,
     143,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    -1,    -1,    -1,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      -1,    81,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,    -1,    -1,    -1,   137,   138,   139,
     140,    -1,    -1,   143,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    -1,    81,    82,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,
      -1,    -1,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,    -1,    -1,    -1,    -1,
     137,   138,   139,   140,    -1,    -1,   143,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,   137,   138,   139,   140,    -1,    -1,   143,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    -1,
      81,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,    -1,    -1,    -1,    -1,   137,   138,   139,   140,
      -1,    -1,   143,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    -1,    81,    82,    83,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,
      -1,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,    -1,    -1,    -1,   137,
     138,   139,   140,    -1,    -1,   143,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    -1,    81,    82,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,    -1,
      -1,    -1,   137,   138,   139,   140,    -1,    -1,   143,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    -1,    81,
      82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   116,    -1,    -1,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    -1,    -1,    -1,    -1,   137,   138,   139,   140,    -1,
      -1,   143,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    -1,    81,    82,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,    -1,    -1,    -1,    -1,   137,   138,
     139,   140,    -1,   142,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    -1,    81,    82,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,
      -1,    -1,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,    -1,    -1,    -1,    -1,
     137,   138,   139,   140,    -1,   142,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    -1,    81,    82,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,    -1,
      -1,    -1,   137,   138,   139,   140,    -1,   142,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    -1,    81,    82,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   116,    -1,    -1,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
      -1,    -1,    -1,    -1,   137,   138,   139,   140,    -1,   142,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    -1,
      81,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,    -1,    -1,    -1,    -1,   137,   138,   139,   140,
      -1,   142,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    -1,    81,    82,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,    -1,    -1,    -1,    -1,   137,   138,
     139,   140,    -1,   142,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    -1,    81,    82,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,
      -1,    -1,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,    -1,    -1,    -1,    -1,
     137,   138,   139,   140,    -1,   142,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    -1,    81,    82,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,    -1,
      -1,    -1,   137,   138,   139,   140,   141,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,   137,   138,   139,   140,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,   137,   138,   139,   140,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,   137,   138,   139,   140,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,   137,   138,   139,   140,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,   137,   138,   139,   140,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,   137,   138,   139,   140,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,   137,   138,   139,   140,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,   137,   138,   139,   140,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    -1,    51,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,   116,    81,    82,    83,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,   137,   138,   139,   140,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,
      -1,    -1,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    51,    52,    -1,    -1,   137,
     138,   139,   140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    -1,    81,    82,    83,    -1,    -1,
      -1,    51,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    71,    72,    73,    74,    75,    76,    77,    78,    79,
     116,    81,    82,    83,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,    -1,    -1,
      -1,   137,   138,   139,   140,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,    -1,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,    -1,    -1,    -1,   137,   138,   139,
     140
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     3,     4,     6,     7,     8,     9,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      25,    26,    27,    29,    30,    33,    34,    35,    37,    38,
      39,    40,    45,    51,    52,    63,    64,    65,    66,    67,
      68,    80,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   112,   115,
     117,   129,   134,   135,   136,   137,   140,   146,   147,   148,
     151,   152,   157,   160,   161,   164,   166,   178,   182,   183,
     185,   186,   189,   190,   191,   142,    99,   104,    16,    29,
     104,   189,    99,   100,   104,   140,   104,   137,   153,   154,
     157,   154,   189,   140,   140,   140,    99,   103,   140,   142,
     142,   142,   189,   189,   189,   189,    16,    99,   156,   158,
      99,   104,   156,    99,    99,   100,   104,   140,   142,   140,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,    99,   104,   189,   154,   154,   154,   189,   189,   189,
     189,   189,   189,   100,   165,   189,   100,   140,   190,   140,
     140,   189,   189,   189,   189,   153,   155,   157,    99,   104,
     143,   187,   188,   189,   191,     0,   147,   142,    29,   104,
     183,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    81,    82,    83,   116,   119,   120,
     121,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   137,   138,   139,   140,   142,    43,   167,   167,    16,
     100,   100,   186,   189,   140,   141,   155,    13,    10,   142,
     189,   189,   165,   140,   165,   165,    24,    24,    99,   103,
     140,   140,    11,    31,    32,   154,   159,   120,   120,   140,
     137,   142,   100,   100,   186,   189,   140,   140,   143,   165,
     165,   189,   141,   153,   157,   122,   122,   119,   143,   143,
     122,   140,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   110,   111,   113,   114,   113,    99,   104,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   165,    27,    28,    99,
     104,   168,   169,   137,   142,   137,   142,   143,   165,   141,
     140,   140,   143,   143,   142,   165,   143,   143,   189,   140,
     140,   165,   165,   189,   140,   140,   140,   189,   189,   189,
     148,   149,   150,   151,   152,   166,   143,   143,   165,   165,
     143,   143,   143,   189,   189,    99,   104,   188,   191,   189,
     165,   122,   141,   144,   143,    99,   104,    99,   104,   119,
      27,    28,    99,   103,   141,   170,   171,   172,   177,   182,
     141,   170,   143,   189,   165,   154,   154,   165,   143,     5,
     184,   184,    11,   189,   165,   143,   143,   143,   189,   189,
     189,   142,   142,   143,   141,   150,   137,   143,   143,   122,
     142,   179,   143,   189,   169,   102,   137,   174,   175,   137,
     175,   140,   165,   141,   171,   172,   177,    99,   103,   141,
     143,   143,    44,   142,   184,    99,   104,   153,   153,   140,
     143,   143,   184,   184,   158,   143,   143,   143,    36,    41,
      42,   162,   163,    99,   104,   180,   181,   184,   179,   104,
      99,   102,   104,   173,   176,   119,   142,   141,   176,   142,
     165,   143,   140,   165,   142,   154,   154,   165,   153,   189,
     154,   184,   153,   153,   154,   140,    71,    73,    74,    78,
      79,   113,   126,   127,   189,   122,   141,   163,   140,   140,
     119,   153,   184,   102,   120,   142,   102,   141,   173,   174,
     141,   143,   179,   165,   143,   143,   143,   153,   189,   189,
     189,   189,   113,   113,   122,   189,   189,   122,   155,   165,
     165,   181,   153,   120,   140,   142,   189,   120,   140,   142,
     179,   184,   143,   179,   154,   143,   122,   122,   122,   122,
     122,   155,   122,   122,   155,   143,   143,   189,   165,   142,
     189,   165,   184,   153,   179,   184,   158,   155,   155,   155,
     155,   155,   155,   155,   142,   143,   142,   143,   153,   184,
     153,   154,   142,   142,   153
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    yyscan_t yyscanner;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {
      case 99: /* "\"identifier\"" */

/* Line 1000 of yacc.c  */
#line 837 "parser.ypp"
	{ free((yyvaluep->string)); };

/* Line 1000 of yacc.c  */
#line 4046 "parser.cpp"
	break;
      case 100: /* "\"variable reference\"" */

/* Line 1000 of yacc.c  */
#line 837 "parser.ypp"
	{ free((yyvaluep->string)); };

/* Line 1000 of yacc.c  */
#line 4055 "parser.cpp"
	break;
      case 101: /* "\"backquote expression\"" */

/* Line 1000 of yacc.c  */
#line 837 "parser.ypp"
	{ free((yyvaluep->string)); };

/* Line 1000 of yacc.c  */
#line 4064 "parser.cpp"
	break;
      case 102: /* "\"in-object member reference\"" */

/* Line 1000 of yacc.c  */
#line 837 "parser.ypp"
	{ free((yyvaluep->string)); };

/* Line 1000 of yacc.c  */
#line 4073 "parser.cpp"
	break;
      case 103: /* "\"identifier or keyword used as function or method identifier\"" */

/* Line 1000 of yacc.c  */
#line 837 "parser.ypp"
	{ free((yyvaluep->string)); };

/* Line 1000 of yacc.c  */
#line 4082 "parser.cpp"
	break;
      case 104: /* "\"namespace or class-scoped reference\"" */

/* Line 1000 of yacc.c  */
#line 837 "parser.ypp"
	{ free((yyvaluep->string)); };

/* Line 1000 of yacc.c  */
#line 4091 "parser.cpp"
	break;
      case 105: /* "\"context reference\"" */

/* Line 1000 of yacc.c  */
#line 837 "parser.ypp"
	{ free((yyvaluep->string)); };

/* Line 1000 of yacc.c  */
#line 4100 "parser.cpp"
	break;
      case 106: /* "\"named context reference\"" */

/* Line 1000 of yacc.c  */
#line 837 "parser.ypp"
	{ free((yyvaluep->string)); };

/* Line 1000 of yacc.c  */
#line 4109 "parser.cpp"
	break;
      case 107: /* "\"date/time value\"" */

/* Line 1000 of yacc.c  */
#line 835 "parser.ypp"
	{ if ((yyvaluep->datetime)) (yyvaluep->datetime)->deref(); };

/* Line 1000 of yacc.c  */
#line 4118 "parser.cpp"
	break;
      case 108: /* "\"quoted string\"" */

/* Line 1000 of yacc.c  */
#line 835 "parser.ypp"
	{ if ((yyvaluep->String)) (yyvaluep->String)->deref(); };

/* Line 1000 of yacc.c  */
#line 4127 "parser.cpp"
	break;
      case 109: /* "\"binary constant value\"" */

/* Line 1000 of yacc.c  */
#line 835 "parser.ypp"
	{ if ((yyvaluep->binary)) (yyvaluep->binary)->deref(); };

/* Line 1000 of yacc.c  */
#line 4136 "parser.cpp"
	break;
      case 110: /* "\"regular expression substitution expression\"" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->RegexSubst); };

/* Line 1000 of yacc.c  */
#line 4145 "parser.cpp"
	break;
      case 111: /* "\"transliteration expression\"" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->RegexTrans); };

/* Line 1000 of yacc.c  */
#line 4154 "parser.cpp"
	break;
      case 113: /* "\"regular expression\"" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->Regex); };

/* Line 1000 of yacc.c  */
#line 4163 "parser.cpp"
	break;
      case 114: /* "\"regular expression extraction expression\"" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->Regex); };

/* Line 1000 of yacc.c  */
#line 4172 "parser.cpp"
	break;
      case 115: /* "\"implicit argument reference\"" */

/* Line 1000 of yacc.c  */
#line 835 "parser.ypp"
	{ if ((yyvaluep->implicit_arg)) (yyvaluep->implicit_arg)->deref(); };

/* Line 1000 of yacc.c  */
#line 4181 "parser.cpp"
	break;
      case 116: /* "\"keyword used as hash key or object member reference\"" */

/* Line 1000 of yacc.c  */
#line 835 "parser.ypp"
	{ if ((yyvaluep->String)) (yyvaluep->String)->deref(); };

/* Line 1000 of yacc.c  */
#line 4190 "parser.cpp"
	break;
      case 148: /* "top_namespace_decl" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->ns); };

/* Line 1000 of yacc.c  */
#line 4199 "parser.cpp"
	break;
      case 149: /* "namespace_decls" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->ns); };

/* Line 1000 of yacc.c  */
#line 4208 "parser.cpp"
	break;
      case 150: /* "namespace_decl" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->nsn); };

/* Line 1000 of yacc.c  */
#line 4217 "parser.cpp"
	break;
      case 151: /* "unscoped_const_decl" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->constnode); };

/* Line 1000 of yacc.c  */
#line 4226 "parser.cpp"
	break;
      case 152: /* "scoped_const_decl" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->constnode); };

/* Line 1000 of yacc.c  */
#line 4235 "parser.cpp"
	break;
      case 153: /* "block" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->sblock); };

/* Line 1000 of yacc.c  */
#line 4244 "parser.cpp"
	break;
      case 154: /* "statement_or_block" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->sblock); };

/* Line 1000 of yacc.c  */
#line 4253 "parser.cpp"
	break;
      case 155: /* "statements" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->sblock); };

/* Line 1000 of yacc.c  */
#line 4262 "parser.cpp"
	break;
      case 156: /* "optname" */

/* Line 1000 of yacc.c  */
#line 837 "parser.ypp"
	{ free((yyvaluep->string)); };

/* Line 1000 of yacc.c  */
#line 4271 "parser.cpp"
	break;
      case 157: /* "statement" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->statement); };

/* Line 1000 of yacc.c  */
#line 4280 "parser.cpp"
	break;
      case 158: /* "context_mods" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->cmods); };

/* Line 1000 of yacc.c  */
#line 4289 "parser.cpp"
	break;
      case 159: /* "context_mod" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->cmod); };

/* Line 1000 of yacc.c  */
#line 4298 "parser.cpp"
	break;
      case 160: /* "return_statement" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->statement); };

/* Line 1000 of yacc.c  */
#line 4307 "parser.cpp"
	break;
      case 161: /* "switch_statement" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->statement); };

/* Line 1000 of yacc.c  */
#line 4316 "parser.cpp"
	break;
      case 162: /* "case_block" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->switchstmt); };

/* Line 1000 of yacc.c  */
#line 4325 "parser.cpp"
	break;
      case 163: /* "case_code" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->casenode); };

/* Line 1000 of yacc.c  */
#line 4334 "parser.cpp"
	break;
      case 164: /* "try_statement" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->statement); };

/* Line 1000 of yacc.c  */
#line 4343 "parser.cpp"
	break;
      case 165: /* "myexp" */

/* Line 1000 of yacc.c  */
#line 836 "parser.ypp"
	{ if ((yyvaluep->node)) (yyvaluep->node)->deref(0); };

/* Line 1000 of yacc.c  */
#line 4352 "parser.cpp"
	break;
      case 166: /* "class_def" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->classdef); };

/* Line 1000 of yacc.c  */
#line 4361 "parser.cpp"
	break;
      case 167: /* "inheritance_list" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->sclist); };

/* Line 1000 of yacc.c  */
#line 4370 "parser.cpp"
	break;
      case 168: /* "superclass_list" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->sclist); };

/* Line 1000 of yacc.c  */
#line 4379 "parser.cpp"
	break;
      case 169: /* "superclass" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->sclnode); };

/* Line 1000 of yacc.c  */
#line 4388 "parser.cpp"
	break;
      case 170: /* "class_attributes" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->qoreclass); };

/* Line 1000 of yacc.c  */
#line 4397 "parser.cpp"
	break;
      case 171: /* "private_member_list" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->memberlist); };

/* Line 1000 of yacc.c  */
#line 4406 "parser.cpp"
	break;
      case 172: /* "public_member_list" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->memberlist); };

/* Line 1000 of yacc.c  */
#line 4415 "parser.cpp"
	break;
      case 173: /* "member2" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->memberinfo); };

/* Line 1000 of yacc.c  */
#line 4424 "parser.cpp"
	break;
      case 174: /* "member" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->memberinfo); };

/* Line 1000 of yacc.c  */
#line 4433 "parser.cpp"
	break;
      case 175: /* "member_list" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->memberlist); };

/* Line 1000 of yacc.c  */
#line 4442 "parser.cpp"
	break;
      case 176: /* "member_list2" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->memberlist); };

/* Line 1000 of yacc.c  */
#line 4451 "parser.cpp"
	break;
      case 177: /* "method_definition" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->methodnode); };

/* Line 1000 of yacc.c  */
#line 4460 "parser.cpp"
	break;
      case 179: /* "base_constructor_list" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->bcalist); };

/* Line 1000 of yacc.c  */
#line 4469 "parser.cpp"
	break;
      case 180: /* "base_constructors" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->bcalist); };

/* Line 1000 of yacc.c  */
#line 4478 "parser.cpp"
	break;
      case 181: /* "base_constructor" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->bcanode); };

/* Line 1000 of yacc.c  */
#line 4487 "parser.cpp"
	break;
      case 184: /* "return_value" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->returnTypeInfo); };

/* Line 1000 of yacc.c  */
#line 4496 "parser.cpp"
	break;
      case 186: /* "list" */

/* Line 1000 of yacc.c  */
#line 836 "parser.ypp"
	{ if ((yyvaluep->list)) (yyvaluep->list)->deref(0); };

/* Line 1000 of yacc.c  */
#line 4505 "parser.cpp"
	break;
      case 187: /* "hash" */

/* Line 1000 of yacc.c  */
#line 836 "parser.ypp"
	{ if ((yyvaluep->hash)) (yyvaluep->hash)->deref(0); };

/* Line 1000 of yacc.c  */
#line 4514 "parser.cpp"
	break;
      case 188: /* "hash_element" */

/* Line 1000 of yacc.c  */
#line 834 "parser.ypp"
	{ delete (yyvaluep->hashelement); };

/* Line 1000 of yacc.c  */
#line 4523 "parser.cpp"
	break;
      case 189: /* "exp" */

/* Line 1000 of yacc.c  */
#line 836 "parser.ypp"
	{ if ((yyvaluep->node)) (yyvaluep->node)->deref(0); };

/* Line 1000 of yacc.c  */
#line 4532 "parser.cpp"
	break;
      case 190: /* "string" */

/* Line 1000 of yacc.c  */
#line 835 "parser.ypp"
	{ if ((yyvaluep->String)) (yyvaluep->String)->deref(); };

/* Line 1000 of yacc.c  */
#line 4541 "parser.cpp"
	break;
      case 191: /* "scalar" */

/* Line 1000 of yacc.c  */
#line 836 "parser.ypp"
	{ if ((yyvaluep->node)) (yyvaluep->node)->deref(0); };

/* Line 1000 of yacc.c  */
#line 4550 "parser.cpp"
	break;

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (yyscan_t yyscanner);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:

/* Line 1455 of yacc.c  */
#line 847 "parser.ypp"
    {
	   addClass((yyvsp[(1) - (1)].classdef)->name, (yyvsp[(1) - (1)].classdef)->oc); 
	   // see if class definitions are allowed
	   if (checkParseOption(PO_NO_CLASS_DEFS))
	      parse_error("illegal class definition \"%s\" (conflicts with parse option NO_CLASS_DEFS)",
			  (yyvsp[(1) - (1)].classdef)->oc->getName());
	   delete (yyvsp[(1) - (1)].classdef);
	}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 855 "parser.ypp"
    { 
	   parseAddConstant((yyvsp[(1) - (1)].constnode)->name, (yyvsp[(1) - (1)].constnode)->value);
	   // see if constant definitions are allowed
	   if (checkParseOption(PO_NO_CONSTANT_DEFS))
	      parse_error("illegal constant definition \"%s\" (conflicts with parse option NO_CONSTANT_DEFS)",
			  (yyvsp[(1) - (1)].constnode)->name->ostr);

	   delete (yyvsp[(1) - (1)].constnode);
	}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 864 "parser.ypp"
    { 
	   getRootNS()->parseAddConstant((yyvsp[(1) - (1)].constnode)->name, (yyvsp[(1) - (1)].constnode)->value); 
	   // see if constant definitions are allowed
	   if (checkParseOption(PO_NO_CONSTANT_DEFS))
	      parse_error("illegal constant definition \"%s\" (conflicts with parse option NO_CONSTANT_DEFS)", (yyvsp[(1) - (1)].constnode)->name->ostr);
	   delete (yyvsp[(1) - (1)].constnode);
	}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 872 "parser.ypp"
    {
	   if ((yyvsp[(1) - (1)].statement)) {
	      if ((yyvsp[(1) - (1)].statement)->isParseDeclaration())
		 delete (yyvsp[(1) - (1)].statement);
	      else
		 getProgram()->addStatement((yyvsp[(1) - (1)].statement));
	   }
	}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 880 "parser.ypp"
    {
	   // set line range
	   (yyvsp[(2) - (3)].sblock)->LineNumber = (yylsp[(1) - (3)]).first_line;
	   (yyvsp[(2) - (3)].sblock)->EndLineNumber = (yylsp[(2) - (3)]).last_line;
	   getProgram()->addStatement((yyvsp[(2) - (3)].sblock));
        }
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 886 "parser.ypp"
    {
	   getRootNS()->parseAddNamespace((yyvsp[(1) - (1)].ns)); 
	   // see if ns declaration is legal
	   if (checkParseOption(PO_NO_NAMESPACE_DEFS))
	      parse_error("illegal namespace definition \"%s\" (conflicts with parse option NO_NAMESPACE_DEFINITION)", (yyvsp[(1) - (1)].ns)->getName());
	}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 896 "parser.ypp"
    { (yyvsp[(4) - (5)].ns)->setName((yyvsp[(2) - (5)].string)); (yyval.ns) = (yyvsp[(4) - (5)].ns); free((yyvsp[(2) - (5)].string)); }
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 898 "parser.ypp"
    { (yyval.ns) = new QoreNamespace((yyvsp[(2) - (3)].string)); free((yyvsp[(2) - (3)].string)); }
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 902 "parser.ypp"
    {
	   QoreNamespace *ns = new QoreNamespace;
	   addNSNode(ns, (yyvsp[(1) - (1)].nsn));
	   (yyval.ns) = ns;
        }
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 907 "parser.ypp"
    { 
	   addNSNode((yyvsp[(1) - (2)].ns), (yyvsp[(2) - (2)].nsn));
	   (yyval.ns) = (yyvsp[(1) - (2)].ns);
	}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 914 "parser.ypp"
    { 
	   (yyval.nsn) = new NSNode((yyvsp[(1) - (1)].constnode)); 
	   // see if constant definitions are allowed
	   if (checkParseOption(PO_NO_CONSTANT_DEFS))
	      parse_error("illegal constant definition \"%s\" (conflicts with parse option NO_CONSTANT_DEFS)",
			  (yyvsp[(1) - (1)].constnode)->name->ostr);
        }
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 921 "parser.ypp"
    { 
	   (yyval.nsn) = new NSNode((yyvsp[(1) - (1)].constnode)); 
	   // see if constant definitions are allowed
	   if (checkParseOption(PO_NO_CONSTANT_DEFS))
	      parse_error("illegal constant definition \"%s\" (conflicts with parse option NO_CONSTANT_DEFS)",
			  (yyvsp[(1) - (1)].constnode)->name->ostr);
	}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 928 "parser.ypp"
    { 
	   (yyval.nsn) = new NSNode((yyvsp[(1) - (1)].classdef)); 
	   // see if class definitions are allowed
	   if (checkParseOption(PO_NO_CLASS_DEFS))
	      parse_error("illegal class definition \"%s\" (conflicts with parse option NO_CLASS_DEFS)",
			  (yyvsp[(1) - (1)].classdef)->oc->getName());
	}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 935 "parser.ypp"
    { 
	   (yyval.nsn) = new NSNode((yyvsp[(1) - (1)].ns)); 
	   // see if ns declaration is legal
	   if (checkParseOption(PO_NO_NAMESPACE_DEFS))
	      parse_error("illegal namespace definition \"%s\" (conflicts with parse option NO_NAMESPACE_DEFINITION)", (yyvsp[(1) - (1)].ns)->getName());
	}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 943 "parser.ypp"
    { 
	   const_ok((yyvsp[(4) - (5)].node));
	   (yyval.constnode) = new ConstNode((yyvsp[(2) - (5)].string), (yyvsp[(4) - (5)].node)); 
	}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 950 "parser.ypp"
    {
	   const_ok((yyvsp[(4) - (5)].node));
	   (yyval.constnode) = new ConstNode((yyvsp[(2) - (5)].string), (yyvsp[(4) - (5)].node)); 
	}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 958 "parser.ypp"
    { (yyval.sblock) = (yyvsp[(2) - (3)].sblock); }
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 961 "parser.ypp"
    { (yyval.sblock) = 0; }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 966 "parser.ypp"
    { (yyval.sblock) = new StatementBlock((yyvsp[(1) - (1)].statement)); }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 969 "parser.ypp"
    { (yyval.sblock) = (yyvsp[(1) - (1)].sblock); }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 974 "parser.ypp"
    { (yyval.sblock) = new StatementBlock((yyvsp[(1) - (1)].statement)); }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 976 "parser.ypp"
    { (yyval.sblock) = new StatementBlock((yyvsp[(1) - (1)].sblock)); }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 978 "parser.ypp"
    { (yyvsp[(1) - (2)].sblock)->addStatement((yyvsp[(2) - (2)].sblock)); (yyval.sblock) = (yyvsp[(1) - (2)].sblock); }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 980 "parser.ypp"
    { (yyvsp[(1) - (2)].sblock)->addStatement((yyvsp[(2) - (2)].statement)); (yyval.sblock) = (yyvsp[(1) - (2)].sblock); }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 985 "parser.ypp"
    { (yyval.string) = 0; }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 986 "parser.ypp"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 990 "parser.ypp"
    {
	   // if the expression has no effect and it's not a variable declaration
	   qore_type_t t = (yyvsp[(1) - (2)].node) ? (yyvsp[(1) - (2)].node)->getType() : 0;
	   if (t == NT_LIST) {
	      QoreListNode *l = reinterpret_cast<QoreListNode *>((yyvsp[(1) - (2)].node));
	      // rewrite expression if it's a list without perentheses under certail
	      // conditions
	      (yyvsp[(1) - (2)].node) = checkRewriteList(l);
	   }

	   if (!hasEffect((yyvsp[(1) - (2)].node))
	       && (t != NT_VARREF)
	       && (t != NT_LIST || !reinterpret_cast<QoreListNode *>((yyvsp[(1) - (2)].node))->isVariableList()))
	      parse_error("statement has no effect (%s)", (yyvsp[(1) - (2)].node) ? (yyvsp[(1) - (2)].node)->getTypeName() : "NOTHING");
	   if (t == NT_TREE)
	      reinterpret_cast<QoreTreeNode *>((yyvsp[(1) - (2)].node))->ignoreReturnValue();
	   else if (t == NT_OPERATOR)
	      reinterpret_cast<QoreOperatorNode *>((yyvsp[(1) - (2)].node))->ignoreReturnValue();
	   (yyval.statement) = new ExpressionStatement((yylsp[(1) - (2)]).first_line, (yylsp[(1) - (2)]).last_line, (yyvsp[(1) - (2)].node));
	}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 1011 "parser.ypp"
    {
	   NamedScope *ns = new NamedScope((yyvsp[(1) - (5)].string));
	   assert(ns->elements > 1);
	   printd(5, "statement: parsing static method call: %s()\n", ns->ostr);
	   (yyval.statement) = new ExpressionStatement((yylsp[(1) - (5)]).first_line, (yylsp[(1) - (5)]).last_line, new StaticMethodCallNode(ns, makeArgs((yyvsp[(3) - (5)].node))));
	}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 1018 "parser.ypp"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 1019 "parser.ypp"
    {
	   (yyval.statement) = new RethrowStatement((yylsp[(1) - (2)]).first_line, (yylsp[(1) - (2)]).last_line);
	}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 1022 "parser.ypp"
    {
	   (yyval.statement) = new ThrowStatement((yylsp[(1) - (3)]).first_line, (yylsp[(2) - (3)]).last_line, (yyvsp[(2) - (3)].node));
	}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 1025 "parser.ypp"
    {
	   (yyval.statement) = new OnBlockExitStatement((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].sblock), OBE_Unconditional);
	}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 1028 "parser.ypp"
    {
	   (yyval.statement) = new OnBlockExitStatement((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].sblock), OBE_Success);
	}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 1031 "parser.ypp"
    {
	   (yyval.statement) = new OnBlockExitStatement((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].sblock), OBE_Error);
	}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 1034 "parser.ypp"
    {
	   (yyval.statement) = new ContextStatement((yylsp[(1) - (3)]).first_line, (yylsp[(3) - (3)]).last_line, 0, 0, (yyvsp[(2) - (3)].cmods), (yyvsp[(3) - (3)].sblock));
	}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 1037 "parser.ypp"
    {
	   (yyval.statement) = new SummarizeStatement((yylsp[(1) - (11)]).first_line, (yylsp[(11) - (11)]).last_line, (yyvsp[(2) - (11)].string), (yyvsp[(4) - (11)].node), (yyvsp[(10) - (11)].cmods), (yyvsp[(11) - (11)].sblock), (yyvsp[(8) - (11)].node));
	}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 1040 "parser.ypp"
    {
	   (yyval.statement) = new ContextStatement((yylsp[(1) - (7)]).first_line, (yylsp[(7) - (7)]).last_line, (yyvsp[(2) - (7)].string), (yyvsp[(4) - (7)].node), (yyvsp[(6) - (7)].cmods), (yyvsp[(7) - (7)].sblock));
        }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 1043 "parser.ypp"
    {	
	   (yyval.statement) = new IfStatement((yylsp[(1) - (5)]).first_line, (yylsp[(5) - (5)]).last_line, (yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock));
	}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 1046 "parser.ypp"
    {
	   (yyval.statement) = new IfStatement((yylsp[(1) - (7)]).first_line, (yylsp[(7) - (7)]).last_line, (yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].sblock), (yyvsp[(7) - (7)].sblock));
	}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 1049 "parser.ypp"
    {
	   (yyval.statement) = new WhileStatement((yylsp[(1) - (5)]).first_line, (yylsp[(5) - (5)]).last_line, (yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock));
	}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 1052 "parser.ypp"
    {
	   (yyval.statement) = new DoWhileStatement((yylsp[(1) - (7)]).first_line, (yylsp[(5) - (7)]).last_line, (yyvsp[(5) - (7)].node), (yyvsp[(2) - (7)].sblock));
	}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 1055 "parser.ypp"
    {
	   (yyval.statement) = new ForStatement((yylsp[(1) - (9)]).first_line, (yylsp[(9) - (9)]).last_line, (yyvsp[(3) - (9)].node), (yyvsp[(5) - (9)].node), (yyvsp[(7) - (9)].node), (yyvsp[(9) - (9)].sblock));
	}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 1058 "parser.ypp"
    {
	   (yyval.statement) = new ForEachStatement((yylsp[(1) - (7)]).first_line, (yylsp[(7) - (7)]).last_line, (yyvsp[(2) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].sblock));
	   qore_type_t t = (yyvsp[(2) - (7)].node) ? (yyvsp[(2) - (7)].node)->getType() : 0;
	   if (t != NT_VARREF && t != NT_SELF_VARREF)
	      parse_error("foreach variable expression is not a variable reference");
	}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 1064 "parser.ypp"
    { (yyval.statement) = (yyvsp[(1) - (2)].statement); }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 1065 "parser.ypp"
    {
	   // see if thread exit is allowed
	   if (checkParseOption(PO_NO_THREAD_CONTROL))
	      parse_error("illegal use of \"thread_exit\" (conflicts with parse option NO_THREAD_CONTROL)");

	   (yyval.statement) = new ThreadExitStatement((yylsp[(1) - (2)]).first_line, (yylsp[(1) - (2)]).last_line); 
	}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 1072 "parser.ypp"
    {
	  (yyval.statement) = new BreakStatement((yylsp[(1) - (2)]).first_line, (yylsp[(1) - (2)]).last_line);
	}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 1075 "parser.ypp"
    {
	  (yyval.statement) = new ContinueStatement((yylsp[(1) - (2)]).first_line, (yylsp[(1) - (2)]).last_line);
	}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 1078 "parser.ypp"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 1079 "parser.ypp"
    { (yyval.statement) = 0; }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 1084 "parser.ypp"
    { (yyval.cmods) = 0; }
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 1086 "parser.ypp"
    { 
	   if (!(yyvsp[(1) - (2)].cmods)) 
	      (yyval.cmods) = new ContextModList((yyvsp[(2) - (2)].cmod)); 
	   else { 
	      (yyvsp[(1) - (2)].cmods)->addContextMod((yyvsp[(2) - (2)].cmod)); 
	      (yyval.cmods) = (yyvsp[(1) - (2)].cmods); 
	   }
	}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 1098 "parser.ypp"
    { (yyval.cmod) = new ContextMod(CM_WHERE_NODE, (yyvsp[(3) - (4)].node)); }
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 1100 "parser.ypp"
    { (yyval.cmod) = new ContextMod(CM_SORT_ASCENDING, (yyvsp[(3) - (4)].node)); }
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 1102 "parser.ypp"
    { (yyval.cmod) = new ContextMod(CM_SORT_DESCENDING, (yyvsp[(3) - (4)].node)); }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 1106 "parser.ypp"
    { (yyval.statement) = new ReturnStatement((yylsp[(1) - (1)]).first_line, (yylsp[(1) - (1)]).last_line); }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 1108 "parser.ypp"
    { (yyval.statement) = new ReturnStatement((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].node)); }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 1113 "parser.ypp"
    {
	   (yyvsp[(6) - (7)].switchstmt)->setSwitch((yyvsp[(3) - (7)].node));
	   (yyval.statement) = (yyvsp[(6) - (7)].switchstmt);
	   (yyval.statement)->LineNumber = (yylsp[(1) - (7)]).first_line;
	   (yyval.statement)->EndLineNumber = (yylsp[(7) - (7)]).last_line;
        }
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 1123 "parser.ypp"
    {
	   (yyval.switchstmt) = new SwitchStatement((yyvsp[(1) - (1)].casenode));
	}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 1127 "parser.ypp"
    {
	   (yyvsp[(1) - (2)].switchstmt)->addCase((yyvsp[(2) - (2)].casenode));
	   (yyval.switchstmt) = (yyvsp[(1) - (2)].switchstmt);
        }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 1135 "parser.ypp"
    {
	   check_case(">=", (yyvsp[(3) - (5)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock), OP_LOG_GE);
        }
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 1140 "parser.ypp"
    {
	   check_case(">=", (yyvsp[(3) - (4)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (4)].node), 0, OP_LOG_GE);
        }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 1146 "parser.ypp"
    {
	   check_case("<=", (yyvsp[(3) - (5)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock), OP_LOG_LE);
        }
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 1151 "parser.ypp"
    {
	   check_case("<=", (yyvsp[(3) - (4)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (4)].node), 0, OP_LOG_LE);
        }
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 1157 "parser.ypp"
    {
	   check_case("==", (yyvsp[(3) - (5)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock), OP_LOG_EQ);
        }
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 1162 "parser.ypp"
    {
	   check_case("==", (yyvsp[(3) - (4)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (4)].node), 0, OP_LOG_EQ);
        }
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 1168 "parser.ypp"
    {
	   check_case("<", (yyvsp[(3) - (5)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock), OP_LOG_LT);
        }
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 1173 "parser.ypp"
    {
	   check_case("<", (yyvsp[(3) - (4)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (4)].node), 0, OP_LOG_LT);
        }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 1179 "parser.ypp"
    {
	   check_case(">", (yyvsp[(3) - (5)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock), OP_LOG_GT);
        }
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 1184 "parser.ypp"
    {
	   check_case(">", (yyvsp[(3) - (4)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (4)].node), 0, OP_LOG_GT);
        }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 1190 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNodeRegex((yyvsp[(3) - (5)].Regex), (yyvsp[(5) - (5)].sblock));
	}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 1194 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNodeRegex((yyvsp[(3) - (4)].Regex), 0);
	}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 1199 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNodeNegRegex((yyvsp[(3) - (5)].Regex), (yyvsp[(5) - (5)].sblock));
	}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 1203 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNodeNegRegex((yyvsp[(3) - (4)].Regex), 0);
	}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 1208 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNodeRegex((yyvsp[(2) - (4)].Regex), (yyvsp[(4) - (4)].sblock));
	}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 1212 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNodeRegex((yyvsp[(2) - (3)].Regex), 0);
	}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 1217 "parser.ypp"
    {
	   check_case(0, (yyvsp[(2) - (4)].node));
	   (yyval.casenode) = new CaseNode((yyvsp[(2) - (4)].node), (yyvsp[(4) - (4)].sblock));
	}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1222 "parser.ypp"
    {
	   check_case(0, (yyvsp[(2) - (3)].node));
	   (yyval.casenode) = new CaseNode((yyvsp[(2) - (3)].node), 0);
	}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1228 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNode(0, (yyvsp[(3) - (3)].sblock));
	}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1232 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNode(0, 0);
	}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1238 "parser.ypp"
    {
	   char *param = 0;
	   if ((yyvsp[(5) - (7)].node)) {
	      if ((yyvsp[(5) - (7)].node)->getType() == NT_VARREF) 
		 param = reinterpret_cast<VarRefNode *>((yyvsp[(5) - (7)].node))->takeName();
	      else
		 parse_error("only one parameter accepted in catch block for exception hash");
	      (yyvsp[(5) - (7)].node)->deref(0);
	   }
	   (yyval.statement) = new TryStatement((yylsp[(1) - (7)]).first_line, (yylsp[(7) - (7)]).last_line, (yyvsp[(2) - (7)].sblock), (yyvsp[(7) - (7)].sblock), param);
	}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 1251 "parser.ypp"
    { (yyval.node) = 0; }
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 1252 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 1256 "parser.ypp"
    {
	   (yyvsp[(5) - (6)].qoreclass)->setName((yyvsp[(2) - (6)].string));
	   (yyvsp[(5) - (6)].qoreclass)->parseSetBaseClassList((yyvsp[(3) - (6)].sclist));
	   (yyval.classdef) = new ObjClassDef((yyvsp[(2) - (6)].string), (yyvsp[(5) - (6)].qoreclass)); 
	}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1261 "parser.ypp"
    { 
	   (yyval.classdef) = new ObjClassDef((yyvsp[(2) - (6)].string), (yyvsp[(5) - (6)].qoreclass)); 
	   (yyvsp[(5) - (6)].qoreclass)->setName((yyval.classdef)->name->getIdentifier()); 
	   (yyvsp[(5) - (6)].qoreclass)->parseSetBaseClassList((yyvsp[(3) - (6)].sclist));
	}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 1266 "parser.ypp"
    { 
	   QoreClass *qc = new QoreClass((yyvsp[(2) - (4)].string));
	   qc->parseSetBaseClassList((yyvsp[(3) - (4)].sclist));
	   (yyval.classdef) = new ObjClassDef((yyvsp[(2) - (4)].string), qc); 	   
	}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 1271 "parser.ypp"
    { 
	   QoreClass *qc = new QoreClass();
	   (yyval.classdef) = new ObjClassDef((yyvsp[(2) - (4)].string), qc);
	   qc->setName((yyval.classdef)->name->getIdentifier());
	   qc->parseSetBaseClassList((yyvsp[(3) - (4)].sclist));
	}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1277 "parser.ypp"
    { 
	   QoreClass *qc = new QoreClass((yyvsp[(2) - (5)].string));
	   qc->parseSetBaseClassList((yyvsp[(3) - (5)].sclist));
	   (yyval.classdef) = new ObjClassDef((yyvsp[(2) - (5)].string), qc); 	   
	}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 1282 "parser.ypp"
    { 
	   QoreClass *qc = new QoreClass();
	   (yyval.classdef) = new ObjClassDef((yyvsp[(2) - (5)].string), qc);
	   qc->setName((yyval.classdef)->name->getIdentifier());
	   qc->parseSetBaseClassList((yyvsp[(3) - (5)].sclist));
	}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 1291 "parser.ypp"
    {
	   (yyval.sclist) = (yyvsp[(2) - (2)].sclist);
        }
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1294 "parser.ypp"
    { // NOTHING
           (yyval.sclist) = 0;
	}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1300 "parser.ypp"
    {
	   (yyval.sclist) = new BCList((yyvsp[(1) - (1)].sclnode));
	}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 1303 "parser.ypp"
    {
	   (yyvsp[(1) - (3)].sclist)->push_back((yyvsp[(3) - (3)].sclnode));
	   (yyval.sclist) = (yyvsp[(1) - (3)].sclist);
        }
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 1310 "parser.ypp"
    {
	   (yyval.sclnode) = new BCNode((yyvsp[(1) - (1)].string), false);
	}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1313 "parser.ypp"
    {
	   (yyval.sclnode) = new BCNode(new NamedScope((yyvsp[(1) - (1)].string)), false);
	}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1316 "parser.ypp"
    {
	   (yyval.sclnode) = new BCNode((yyvsp[(2) - (2)].string), false);
	}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1319 "parser.ypp"
    {
	   (yyval.sclnode) = new BCNode(new NamedScope((yyvsp[(2) - (2)].string)), false);
	}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1322 "parser.ypp"
    {
	   (yyval.sclnode) = new BCNode((yyvsp[(2) - (2)].string), true);
	}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1325 "parser.ypp"
    {
	   (yyval.sclnode) = new BCNode(new NamedScope((yyvsp[(2) - (2)].string)), true);
	}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1331 "parser.ypp"
    { 
           (yyval.qoreclass) = new QoreClass;
	   (yyvsp[(1) - (1)].methodnode)->addAndDelete((yyval.qoreclass));
	}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1335 "parser.ypp"
    {
	   (yyval.qoreclass) = new QoreClass;
	   (yyvsp[(1) - (1)].memberlist)->mergePrivateMembers((yyval.qoreclass));
	   delete (yyvsp[(1) - (1)].memberlist);
	}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1340 "parser.ypp"
    {
	   (yyval.qoreclass) = new QoreClass;
	   (yyvsp[(1) - (1)].memberlist)->mergePublicMembers((yyval.qoreclass));
	   delete (yyvsp[(1) - (1)].memberlist);
	}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1345 "parser.ypp"
    { 
	   (yyvsp[(2) - (2)].methodnode)->addAndDelete((yyvsp[(1) - (2)].qoreclass));
	   (yyval.qoreclass) = (yyvsp[(1) - (2)].qoreclass); 
	}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1349 "parser.ypp"
    { 
	   (yyvsp[(2) - (2)].memberlist)->mergePrivateMembers((yyvsp[(1) - (2)].qoreclass));
	   (yyval.qoreclass) = (yyvsp[(1) - (2)].qoreclass);
	   delete (yyvsp[(2) - (2)].memberlist);
	}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1354 "parser.ypp"
    {
	   (yyvsp[(2) - (2)].memberlist)->mergePublicMembers((yyvsp[(1) - (2)].qoreclass));
	   (yyval.qoreclass) = (yyvsp[(1) - (2)].qoreclass); 
	   delete (yyvsp[(2) - (2)].memberlist);
	}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1362 "parser.ypp"
    {
	   (yyval.memberlist) = (yyvsp[(2) - (3)].memberlist);
	}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1365 "parser.ypp"
    {
	   (yyval.memberlist) = (yyvsp[(3) - (4)].memberlist);
	}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1371 "parser.ypp"
    {
	   (yyval.memberlist) = (yyvsp[(2) - (3)].memberlist);
	}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1374 "parser.ypp"
    {
	   (yyval.memberlist) = (yyvsp[(3) - (4)].memberlist);
	}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1377 "parser.ypp"
    {
	   (yyval.memberlist) = new EmptyPublicMemberList;
	}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1383 "parser.ypp"
    {
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(1) - (2)].string), 0);
        }
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1386 "parser.ypp"
    {
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(1) - (4)].string), new QoreMemberInfo((yylsp[(1) - (4)]).first_line, (yylsp[(2) - (4)]).last_line, (yyvsp[(3) - (4)].node)));
        }
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1389 "parser.ypp"
    {
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(2) - (3)].string), new QoreMemberInfo((yylsp[(1) - (3)]).first_line, (yylsp[(2) - (3)]).last_line, (yyvsp[(1) - (3)].string)));
	}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1392 "parser.ypp"
    {
	   const QoreTypeInfo *t = getBuiltinUserTypeInfo((yyvsp[(1) - (3)].string));
	   QoreMemberInfo *memberInfo;
	   if (t) {
	      memberInfo = new QoreMemberInfo((yylsp[(1) - (3)]).first_line, (yylsp[(2) - (3)]).last_line, t);
	      free((yyvsp[(1) - (3)].string));
	   }
	   else
	      memberInfo = new QoreMemberInfo((yylsp[(1) - (3)]).first_line, (yylsp[(2) - (3)]).last_line, (yyvsp[(1) - (3)].string));
	   
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(2) - (3)].string), memberInfo);
        }
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 1404 "parser.ypp"
    {
	   const QoreTypeInfo *t = getBuiltinUserTypeInfo((yyvsp[(1) - (5)].string));
	   QoreMemberInfo *memberInfo;
	   if (t) {
	      memberInfo = new QoreMemberInfo((yylsp[(1) - (5)]).first_line, (yylsp[(4) - (5)]).last_line, t, (yyvsp[(4) - (5)].node));
	      free((yyvsp[(1) - (5)].string));
	   }
	   else
	      memberInfo = new QoreMemberInfo((yylsp[(1) - (5)]).first_line, (yylsp[(4) - (5)]).last_line, (yyvsp[(1) - (5)].string), (yyvsp[(4) - (5)].node));

	   (yyval.memberinfo) = new MemberInfo((yyvsp[(2) - (5)].string), memberInfo);
        }
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 1416 "parser.ypp"
    {
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(2) - (5)].string), new QoreMemberInfo((yylsp[(1) - (5)]).first_line, (yylsp[(4) - (5)]).last_line, (yyvsp[(1) - (5)].string), (yyvsp[(4) - (5)].node)));
	}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1419 "parser.ypp"
    {
	   const QoreTypeInfo *t = getBuiltinUserTypeInfo((yyvsp[(1) - (6)].string));
	   QoreMemberInfo *memberInfo;
	   if (t) {
	      parse_error("cannot call constructor for non-class base type '%s'", (yyvsp[(1) - (6)].string));
	      memberInfo = new QoreMemberInfo((yylsp[(1) - (6)]).first_line, (yylsp[(4) - (6)]).last_line, t, (yyvsp[(4) - (6)].node));
	      free((yyvsp[(1) - (6)].string));
	   }
	   else {
	      ScopedObjectCallNode *new_call = new ScopedObjectCallNode(new NamedScope(strdup((yyvsp[(1) - (6)].string))), makeArgs((yyvsp[(4) - (6)].node)));
	      memberInfo = new QoreMemberInfo((yylsp[(1) - (6)]).first_line, (yylsp[(4) - (6)]).last_line, (yyvsp[(1) - (6)].string), new_call);
	   }

	   (yyval.memberinfo) = new MemberInfo((yyvsp[(2) - (6)].string), memberInfo);
        }
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1434 "parser.ypp"
    {
	   ScopedObjectCallNode *new_call = new ScopedObjectCallNode(new NamedScope(strdup((yyvsp[(1) - (6)].string))), makeArgs((yyvsp[(4) - (6)].node)));
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(2) - (6)].string), new QoreMemberInfo((yylsp[(1) - (6)]).first_line, (yylsp[(4) - (6)]).last_line, (yyvsp[(1) - (6)].string), new_call));
	}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 1441 "parser.ypp"
    {
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(1) - (1)].string), 0);
        }
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 1444 "parser.ypp"
    {
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(1) - (2)].string), new QoreMemberInfo((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].string)));
	}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1450 "parser.ypp"
    {
	   (yyval.memberlist) = new MemberList((yyvsp[(1) - (1)].memberinfo));
        }
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1453 "parser.ypp"
    {
	   (yyvsp[(1) - (3)].memberlist)->add((yyvsp[(3) - (3)].memberinfo));
	   (yyval.memberlist) = (yyvsp[(1) - (3)].memberlist);
	}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 1460 "parser.ypp"
    {
	   (yyval.memberlist) = new MemberList((yyvsp[(1) - (1)].memberinfo));
        }
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1463 "parser.ypp"
    {
	   (yyvsp[(1) - (2)].memberlist)->add((yyvsp[(2) - (2)].memberinfo));
	   (yyval.memberlist) = (yyvsp[(1) - (2)].memberlist);
	}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1470 "parser.ypp"
    {
	   checkMethod((yyvsp[(2) - (8)].string), (yyvsp[(6) - (8)].bcalist), (yyvsp[(7) - (8)].returnTypeInfo));
	   (yyval.methodnode) = new MethodNode((yyvsp[(2) - (8)].string), newMethodVariant((yyvsp[(2) - (8)].string), (yyvsp[(1) - (8)].i4), (yylsp[(4) - (8)]).first_line, (yylsp[(4) - (8)]).last_line, (yyvsp[(4) - (8)].node), (yyvsp[(6) - (8)].bcalist), (yyvsp[(7) - (8)].returnTypeInfo), (yyvsp[(8) - (8)].sblock)), (yyvsp[(1) - (8)].i4) & OFM_STATIC);
	}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 1474 "parser.ypp"
    {
	   checkMethod((yyvsp[(2) - (7)].string), (yyvsp[(5) - (7)].bcalist), (yyvsp[(6) - (7)].returnTypeInfo));
	   (yyval.methodnode) = new MethodNode((yyvsp[(2) - (7)].string), newMethodVariant((yyvsp[(2) - (7)].string), (yyvsp[(1) - (7)].i4), (yylsp[(3) - (7)]).first_line, (yylsp[(3) - (7)]).last_line, (yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].bcalist), (yyvsp[(6) - (7)].returnTypeInfo), (yyvsp[(7) - (7)].sblock)), (yyvsp[(1) - (7)].i4) & OFM_STATIC);
	}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 1478 "parser.ypp"
    {
	   checkMethod((yyvsp[(1) - (7)].string), (yyvsp[(5) - (7)].bcalist), (yyvsp[(6) - (7)].returnTypeInfo));
	   (yyval.methodnode) = new MethodNode((yyvsp[(1) - (7)].string), newMethodVariant((yyvsp[(1) - (7)].string), 0, (yylsp[(3) - (7)]).first_line, (yylsp[(3) - (7)]).last_line, (yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].bcalist), (yyvsp[(6) - (7)].returnTypeInfo), (yyvsp[(7) - (7)].sblock)), false);
	}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1482 "parser.ypp"
    {
	   checkMethod((yyvsp[(1) - (6)].string), (yyvsp[(4) - (6)].bcalist), (yyvsp[(5) - (6)].returnTypeInfo));
	   (yyval.methodnode) = new MethodNode((yyvsp[(1) - (6)].string), newMethodVariant((yyvsp[(1) - (6)].string), 0, (yylsp[(2) - (6)]).first_line, (yylsp[(2) - (6)]).last_line, (yyvsp[(2) - (6)].node), (yyvsp[(4) - (6)].bcalist), (yyvsp[(5) - (6)].returnTypeInfo), (yyvsp[(6) - (6)].sblock)), false);
	}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1489 "parser.ypp"
    {
	   tryAddMethod((yyvsp[(1) - (8)].i4), (yyvsp[(2) - (8)].string), (yylsp[(4) - (8)]).first_line, (yylsp[(4) - (8)]).last_line, (yyvsp[(4) - (8)].node), (yyvsp[(6) - (8)].bcalist), (yyvsp[(7) - (8)].returnTypeInfo), (yyvsp[(8) - (8)].sblock));
	}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1492 "parser.ypp"
    {
	   tryAddMethod(0, (yyvsp[(1) - (7)].string), (yylsp[(3) - (7)]).first_line, (yylsp[(3) - (7)]).last_line, (yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].bcalist), (yyvsp[(6) - (7)].returnTypeInfo), (yyvsp[(7) - (7)].sblock));
	}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1498 "parser.ypp"
    {
	   (yyval.bcalist) = (yyvsp[(2) - (2)].bcalist);
	}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1501 "parser.ypp"
    { // nothing
	   (yyval.bcalist) = 0;
	}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 1507 "parser.ypp"
    {
	   (yyval.bcalist) = new BCAList((yyvsp[(1) - (1)].bcanode));
	}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 1510 "parser.ypp"
    {
	   (yyvsp[(1) - (3)].bcalist)->push_back((yyvsp[(3) - (3)].bcanode));
	   (yyval.bcalist) = (yyvsp[(1) - (3)].bcalist);
	}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 1517 "parser.ypp"
    {
	   (yyval.bcanode) = new BCANode((yyvsp[(1) - (4)].string), makeArgs((yyvsp[(3) - (4)].node)));
	}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 1520 "parser.ypp"
    {
	   (yyval.bcanode) = new BCANode(new NamedScope((yyvsp[(1) - (4)].string)), makeArgs((yyvsp[(3) - (4)].node)));
	}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 1526 "parser.ypp"
    { (yyval.i4) = (yyvsp[(1) - (1)].i4); }
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1527 "parser.ypp"
    {
	   if (((yyvsp[(1) - (2)].i4) | (yyvsp[(2) - (2)].i4)) == (yyvsp[(1) - (2)].i4))
	      parse_error("double object method modifier");
	   (yyval.i4) = (yyvsp[(1) - (2)].i4) | (yyvsp[(2) - (2)].i4); 
	}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 1535 "parser.ypp"
    { (yyval.i4) = OFM_PRIVATE; }
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 1536 "parser.ypp"
    { (yyval.i4) = OFM_SYNCED; }
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 1537 "parser.ypp"
    { (yyval.i4) = OFM_STATIC; }
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1541 "parser.ypp"
    {
	   const QoreTypeInfo *t = getBuiltinUserTypeInfo((yyvsp[(2) - (2)].string));
	   QoreParseTypeInfo *p;
	   if (!t)
	      p = new QoreParseTypeInfo((yyvsp[(2) - (2)].string));
	   else {
	      p = 0;
	      free((yyvsp[(2) - (2)].string));
	   }

	   (yyval.returnTypeInfo) = new RetTypeInfo(p, t);
	}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1553 "parser.ypp"
    {
	   (yyval.returnTypeInfo) = new RetTypeInfo(new QoreParseTypeInfo((yyvsp[(2) - (2)].string)), 0);
	}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1557 "parser.ypp"
    {
	   (yyval.returnTypeInfo) = 0;
	}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1562 "parser.ypp"
    { 
	   int ar = get_pop_argv_ref();
	   addUserFunctionVariant((yyvsp[(2) - (7)].string), new UserFunctionVariant((yyvsp[(7) - (7)].sblock), (yylsp[(4) - (7)]).first_line, (yylsp[(4) - (7)]).last_line, (yyvsp[(4) - (7)].node), (yyvsp[(6) - (7)].returnTypeInfo), false, ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS));
	}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1566 "parser.ypp"
    {
	   int ar = get_pop_argv_ref();
	   addUserFunctionVariant((yyvsp[(3) - (8)].string), new UserFunctionVariant((yyvsp[(8) - (8)].sblock), (yylsp[(5) - (8)]).first_line, (yylsp[(5) - (8)]).last_line, (yyvsp[(5) - (8)].node), (yyvsp[(7) - (8)].returnTypeInfo), true, ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS));
	}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1570 "parser.ypp"
    { 
	   int ar = get_pop_argv_ref();
	   addUserFunctionVariant((yyvsp[(2) - (6)].string), new UserFunctionVariant((yyvsp[(6) - (6)].sblock), (yylsp[(3) - (6)]).first_line, (yylsp[(3) - (6)]).last_line, (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].returnTypeInfo), false, ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS));
	}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1574 "parser.ypp"
    {
	   int ar = get_pop_argv_ref();
	   addUserFunctionVariant((yyvsp[(3) - (7)].string), new UserFunctionVariant((yyvsp[(7) - (7)].sblock), (yylsp[(4) - (7)]).first_line, (yylsp[(4) - (7)]).last_line, (yyvsp[(4) - (7)].node), (yyvsp[(6) - (7)].returnTypeInfo), true, ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS)); 
	}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1582 "parser.ypp"
    { (yyval.list) = splice_expressions((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node)); }
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1583 "parser.ypp"
    {
	   QoreListNode *l;
	   if ((yyvsp[(1) - (2)].node) && (yyvsp[(1) - (2)].node)->getType() == NT_LIST) 
	      l = reinterpret_cast<QoreListNode *>((yyvsp[(1) - (2)].node));
	   else {
	      l = new QoreListNode;
	      l->push((yyvsp[(1) - (2)].node));
	      // parse_error("problem in parsing ',' in list: left side of comma is not a list (type: '%s')", $1 ? $1->getTypeName() : "NOTHING");
	      // so we don't insert null values in the parse tree
	      //l = new QoreListNode();
	   }
	   (yyval.list) = l;
        }
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1599 "parser.ypp"
    {
	   (yyval.hash) = new QoreHashNode;
	   (yyval.hash)->setKeyValue((yyvsp[(1) - (1)].hashelement)->key, (yyvsp[(1) - (1)].hashelement)->value, 0);
	   delete (yyvsp[(1) - (1)].hashelement);
	}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1604 "parser.ypp"
    {
	   if ((yyvsp[(1) - (3)].hash)->existsKey((yyvsp[(3) - (3)].hashelement)->key))
	      QoreHashNode::doDuplicateKeyWarning((yyvsp[(3) - (3)].hashelement)->key);
	   (yyvsp[(1) - (3)].hash)->setKeyValue((yyvsp[(3) - (3)].hashelement)->key, (yyvsp[(3) - (3)].hashelement)->value, 0);
	   delete (yyvsp[(3) - (3)].hashelement);
	   (yyval.hash) = (yyvsp[(1) - (3)].hash);
	}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1612 "parser.ypp"
    { /* empty ',' on end of hash */ (yyval.hash)=(yyvsp[(1) - (2)].hash); }
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1617 "parser.ypp"
    { (yyval.hashelement) = new HashElement((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node)); }
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1619 "parser.ypp"
    { (yyval.hashelement) = new HashElement(HE_TAG_CONST, (yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].node)); }
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1621 "parser.ypp"
    { (yyval.hashelement) = new HashElement(HE_TAG_SCOPED_CONST, (yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].node)); }
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1625 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1627 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].binary); }
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1629 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].list); }
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1631 "parser.ypp"
    { (yyval.node) = (yyvsp[(2) - (3)].hash); }
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1633 "parser.ypp"
    { (yyval.node) = new ConstantNode((yyvsp[(1) - (1)].string)); }
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1634 "parser.ypp"
    { 
	   if (!strcmp((yyvsp[(1) - (1)].string), "argv"))
	      inc_argv_ref();
	   (yyval.node) = new VarRefNode((yyvsp[(1) - (1)].string), VT_UNRESOLVED);	   
	}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1639 "parser.ypp"
    {
	   const QoreTypeInfo *t = getBuiltinUserTypeInfo((yyvsp[(1) - (2)].string));
	   if (t) {
	      (yyval.node) = new VarRefDeclNode((yyvsp[(2) - (2)].string), VT_UNRESOLVED, t);
	      free((yyvsp[(1) - (2)].string));
	   }
	   else
	      (yyval.node) = new VarRefDeclNode((yyvsp[(2) - (2)].string), VT_UNRESOLVED, (yyvsp[(1) - (2)].string));
	   //$$ = (t >= 0 ? new VarRefDeclNode($2, VT_UNRESOLVED, t) : new VarRefDeclNode($2, VT_UNRESOLVED, $1));
	}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1649 "parser.ypp"
    {
	   (yyval.node) = new VarRefDeclNode((yyvsp[(2) - (2)].string), VT_UNRESOLVED, (yyvsp[(1) - (2)].string));
	}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1652 "parser.ypp"
    { 
	   // see if types are required
	   if (checkParseOption(PO_REQUIRE_TYPES))
	      parse_error("local variable '$%s' declared without type information, but parse options require all declarations to have type information", (yyvsp[(2) - (2)].string));
	   (yyval.node) = new VarRefNode((yyvsp[(2) - (2)].string), VT_LOCAL); 
	}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1658 "parser.ypp"
    {
	   const QoreTypeInfo *t = getBuiltinUserTypeInfo((yyvsp[(2) - (3)].string));
	   if (t) {
	      (yyval.node) = new VarRefDeclNode((yyvsp[(3) - (3)].string), VT_LOCAL, t);
	      free((yyvsp[(2) - (3)].string));
	   }
	   else
	      (yyval.node) = new VarRefDeclNode((yyvsp[(3) - (3)].string), VT_LOCAL, (yyvsp[(2) - (3)].string));
	}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1667 "parser.ypp"
    {
	   (yyval.node) = new VarRefDeclNode((yyvsp[(3) - (3)].string), VT_LOCAL, (yyvsp[(2) - (3)].string)); 
	}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1670 "parser.ypp"
    {
	   (yyvsp[(3) - (4)].list)->setVariableList();
	   for (unsigned i = 0; i < (yyvsp[(3) - (4)].list)->size(); i++) {
	      AbstractQoreNode *n = (yyvsp[(3) - (4)].list)->retrieve_entry(i);
	      if (!n || n->getType() != NT_VARREF)
		 parse_error("element %d in list following 'my' is not a variable reference (%s)", i, n ? n->getTypeName() : "NOTHING");
	      else {
		 VarRefNode *v = reinterpret_cast<VarRefNode *>(n);
		 // see if types are required
		 if (checkParseOption(PO_REQUIRE_TYPES) && !v->isDecl())
		    parse_error("local variable '$%s' declared without type information, but parse options require all declarations to have type information", v->getName());

		 if (v->getType() == VT_LOCAL)
		    parse_error("illegal use of 'my %s' in local variable declaration list", v->getName());
		 else if (v->getType() == VT_GLOBAL)
		    parse_error("illegal use of 'our %s' in local variable declaration list", v->getName());
		 else
		    v->makeLocal();
	      }
	   }
	   (yyval.node) = (yyvsp[(3) - (4)].list);
	}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1692 "parser.ypp"
    {
	   // see if types are required
	   if (checkParseOption(PO_REQUIRE_TYPES))
	      parse_error("global variable '$%s' declared without type information, but parse options require all declarations to have type information", (yyvsp[(2) - (2)].string));

	   VarRefNode *v = new VarRefNode((yyvsp[(2) - (2)].string), getProgram()->addGlobalVarDef((yyvsp[(2) - (2)].string), 0));
	   (yyval.node) = v;
	}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1700 "parser.ypp"
    {
	   const QoreTypeInfo *t = getBuiltinUserTypeInfo((yyvsp[(2) - (3)].string));
	   VarRefNode *v;
	   if (t) {
	      v = new VarRefNode((yyvsp[(3) - (3)].string), getProgram()->addResolvedGlobalVarDef((yyvsp[(3) - (3)].string), t));
	      free((yyvsp[(2) - (3)].string));
	   }
	   else {
	      v = new VarRefNode((yyvsp[(3) - (3)].string), getProgram()->addGlobalVarDef((yyvsp[(3) - (3)].string), new QoreParseTypeInfo((yyvsp[(2) - (3)].string))));
	   }
	   (yyval.node) = v;
	}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1712 "parser.ypp"
    {
	   VarRefNode *v = new VarRefNode((yyvsp[(3) - (3)].string), getProgram()->addGlobalVarDef((yyvsp[(3) - (3)].string), new QoreParseTypeInfo((yyvsp[(2) - (3)].string))));
	   (yyval.node) = v;
	}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1716 "parser.ypp"
    { 
	   (yyvsp[(3) - (4)].list)->setVariableList();
	   for (unsigned i = 0; i < (yyvsp[(3) - (4)].list)->size(); i++) {
	      AbstractQoreNode *n = (yyvsp[(3) - (4)].list)->retrieve_entry(i);
	      if (!n || n->getType() != NT_VARREF) 
		 parse_error("element %d in list following 'our' is not a variable reference (%s)", i, n ? n->getTypeName() : "NOTHING");
	      else {
		 VarRefNode *v = reinterpret_cast<VarRefNode *>(n);
		 // see if types are required
		 if (checkParseOption(PO_REQUIRE_TYPES) && !v->isDecl())
		    parse_error("global variable '$%s' declared without type information, but parse options require all declarations to have type information", v->getName());

		 if (v->getType() == VT_LOCAL)
		    parse_error("illegal use of 'my %s' in global variable declaration list", v->getName());
		 else if (v->getType() == VT_GLOBAL)
		    parse_error("illegal use of 'our %s' in global variable declaration list", v->getName());
		 else {
		    v->makeGlobal();
		 }
	      }
	   }
	   (yyval.node) = (yyvsp[(3) - (4)].list);
	}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1740 "parser.ypp"
    { (yyval.node) = new BarewordNode((yyvsp[(1) - (1)].string)); }
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1742 "parser.ypp"
    { (yyval.node) = new ContextrefNode((yyvsp[(1) - (1)].string)); }
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1744 "parser.ypp"
    { (yyval.node) = new ContextRowNode(); }
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1746 "parser.ypp"
    { (yyval.node) = new ComplexContextrefNode((yyvsp[(1) - (1)].string)); }
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1748 "parser.ypp"
    { (yyval.node) = new FindNode((yyvsp[(2) - (8)].node), (yyvsp[(4) - (8)].node), (yyvsp[(7) - (8)].node)); }
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1749 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(1) - (3)].node))) {
	      parse_error("left-hand side of plus-equals operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_PLUS_EQUALS, (yyvsp[(3) - (3)].node));
	}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1757 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(1) - (3)].node))) {
	      parse_error("left-hand side of minus-equals operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_MINUS_EQUALS, (yyvsp[(3) - (3)].node));
	}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1765 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(1) - (3)].node))) {
	      parse_error("left-hand side of and-equals operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_AND_EQUALS, (yyvsp[(3) - (3)].node));
	}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1773 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(1) - (3)].node))) {
	      parse_error("left-hand side of or-equals operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_OR_EQUALS, (yyvsp[(3) - (3)].node));
	}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1781 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(1) - (3)].node))) {
	      parse_error("left-hand side of modula-equals operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_MODULA_EQUALS, (yyvsp[(3) - (3)].node));
	}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1789 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(1) - (3)].node))) {
	      parse_error("left-hand side of multiply-equals operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_MULTIPLY_EQUALS, (yyvsp[(3) - (3)].node));
	}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1797 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(1) - (3)].node))) {
	      parse_error("left-hand side of divide-equals operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_DIVIDE_EQUALS, (yyvsp[(3) - (3)].node));
	}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1805 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(1) - (3)].node))) {
	      parse_error("left-hand side of xor-equals operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_XOR_EQUALS, (yyvsp[(3) - (3)].node));
	}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1813 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(1) - (3)].node)))
	   {
	      parse_error("left-hand side of shift-left-equals operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_SHIFT_LEFT_EQUALS, (yyvsp[(3) - (3)].node));
	}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1822 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(1) - (3)].node)))
	   {
	      parse_error("left-hand side of shift-right-equals operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_SHIFT_RIGHT_EQUALS, (yyvsp[(3) - (3)].node));
	}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1831 "parser.ypp"
    {
	   if ((yyvsp[(1) - (3)].node) && (yyvsp[(1) - (3)].node)->getType() == NT_LIST) {
	      QoreListNode *l = reinterpret_cast<QoreListNode *>((yyvsp[(1) - (3)].node));
	      bool ok = true;
	      for (unsigned i = 0; i < l->size(); i++) {
		 AbstractQoreNode *n = l->retrieve_entry(i);
		 if (check_lvalue(n)) {
		    parse_error("element %d in list assignment is not an lvalue (%s)", i, n->getTypeName());
		    ok = false;
		 }
	      }
	      if (ok)
		 (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LIST_ASSIGNMENT, (yyvsp[(3) - (3)].node));
	      else
		 (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	   }
	   else {
	      if (check_lvalue((yyvsp[(1) - (3)].node))) {
		 parse_error("left-hand side of assignment is not an lvalue (%s)", (yyvsp[(1) - (3)].node)->getTypeName());
		 (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	      }
	      else
		 (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_ASSIGNMENT, (yyvsp[(3) - (3)].node));
	   }
	   //print_tree($1, 0);
	}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1858 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_EXISTS, 0); }
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1860 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_ELEMENTS, 0); }
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1861 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_INSTANCEOF, new ClassRefNode((yyvsp[(3) - (3)].string)));
	}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1864 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_INSTANCEOF, new ClassRefNode((yyvsp[(3) - (3)].string)));
	}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1868 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_KEYS, 0); }
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1869 "parser.ypp"
    {  // unshift list, element
	   QoreListNode *l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode *>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l || l->size() != 2) {
	      parse_error("invalid arguments to unshift, expected: lvalue, expression (%s)", (yyvsp[(2) - (2)].node)->getTypeName());
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode *lv = l->shift();
	      if (check_lvalue(lv)) {
		 parse_error("first argument to unshift is not an lvalue");
		 (yyval.node) = makeErrorTree(lv, l->shift());
	      }
	      else
		 (yyval.node) = new QoreTreeNode(lv, OP_UNSHIFT, l->shift());
	      (yyvsp[(2) - (2)].node)->deref(0);
	   }
	}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1886 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(2) - (2)].node))) {
	      parse_error("argument to shift operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0); 
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_SHIFT, 0); 
	}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1894 "parser.ypp"
    {  // push lvalue-list, element
	   QoreListNode *l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode *>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l || l->size() != 2) {
	      parse_error("invalid arguments to push, expected: lvalue, expression (%s)", (yyvsp[(2) - (2)].node)->getTypeName());
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode *lv = l->shift();
	      if (check_lvalue(lv)) {
		 parse_error("first argument to push is not an lvalue");
		 (yyval.node) = makeErrorTree(lv, l->shift());
	      }
	      else
		 (yyval.node) = new QoreTreeNode(lv, OP_PUSH, l->shift());
	      (yyvsp[(2) - (2)].node)->deref(0);
	   }
	}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1911 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(2) - (2)].node))) {
	      parse_error("argument to pop operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0); 
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_POP, 0); 
	}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1919 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(2) - (2)].node))) {
	      parse_error("argument to chomp operator is not an lvalue (use the chomp() function instead)");
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0); 
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_CHOMP, 0); 
	}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1927 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(2) - (2)].node))) {
	      parse_error("argument to trim operator is not an lvalue (use the trim() function instead)");
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0); 
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_TRIM, 0); 
	}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1935 "parser.ypp"
    {  // splice lvalue-list, offset, [length, list]
	   QoreListNode *l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode *>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l) {
	      parse_error("invalid arguments to splice, expected: lvalue, offset exp[, length exp[, list exp]] (got %s)", get_type_name((yyvsp[(2) - (2)].node)));
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else if (l->size() < 2) {
	      parse_error("too few arguments to splice, expected at least 2 arguments as follows: lvalue, offset exp[, length exp[, list exp]] (got %d arguments)", l->size());
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else if (l->size() > 4) {
	      parse_error("too many arguments to splice, expected maximum 4 arguments as follows: lvalue, offset exp[, length exp[, list exp]] (got %d arguments)", l->size());
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode *lv = l->shift();
	      if (check_lvalue(lv)) {
		 parse_error("first argument to splice is not an lvalue");
		 (yyval.node) = makeErrorTree(lv, (yyvsp[(2) - (2)].node));
	      }
	      else {
		 (yyval.node) = new QoreSpliceOperatorNode(lv, l->shift(), l->shift(), l->shift());
		 discard(l, 0);
	      }
	   }
	}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1961 "parser.ypp"
    {  // extract lvalue-list, offset, [length, list]
	   QoreListNode *l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode *>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l) {
	      parse_error("invalid arguments to extract, expected: lvalue, offset exp[, length exp[, list exp]] (got %s)", get_type_name((yyvsp[(2) - (2)].node)));
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else if (l->size() < 2) {
	      parse_error("too few arguments to extract, expected at least 2 arguments as follows: lvalue, offset exp[, length exp[, list exp]] (got %d arguments)", l->size());
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else if (l->size() > 4) {
	      parse_error("too many arguments to extract, expected maximum 4 arguments as follows: lvalue, offset exp[, length exp[, list exp]] (got %d arguments)", l->size());
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode *lv = l->shift();
	      if (check_lvalue(lv)) {
		 parse_error("first argument to extract is not an lvalue");
		 (yyval.node) = makeErrorTree(lv, (yyvsp[(2) - (2)].node));
	      }
	      else {
		 (yyval.node) = new QoreExtractOperatorNode(lv, l->shift(), l->shift(), l->shift());
		 discard(l, 0);
	      }
	   }
	}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1987 "parser.ypp"
    {
	   pop_ignore_numeric_argv_ref();
	   QoreListNode *l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode *>((yyvsp[(2) - (2)].node)) : 0;
	   int len = l ? (int)l->size() : 0;
	   if (!l || len < 2 || len > 3) {
	      parse_error("invalid arguments to map operator, expected: 2 or 3 element list (code expression, list argument, [select expression]), got: '%s'", get_type_name((yyvsp[(2) - (2)].node)));
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else if (len == 2) {
	      AbstractQoreNode *map_exp = l->shift();
	      AbstractQoreNode *arg = l->shift();
	      (yyval.node) = new QoreTreeNode(map_exp, OP_MAP, arg);
	      (yyvsp[(2) - (2)].node)->deref(0);
	   }
	   else {
	      AbstractQoreNode *map_exp = l->shift();
	      (yyval.node) = new QoreTreeNode(map_exp, OP_MAP_SELECT, l);
	   }
	}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 2006 "parser.ypp"
    {
	   pop_ignore_numeric_argv_ref();
	   QoreListNode *l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode *>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l || l->size() != 2) {
	      parse_error("invalid arguments to foldr operator, expected: 2-element list expected: 2-element list (fold expression and list expression), got: '%s'", get_type_name((yyvsp[(2) - (2)].node)));
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode *code_exp = l->shift();
	      AbstractQoreNode *arg = l->shift();
	      (yyval.node) = new QoreTreeNode(code_exp, OP_FOLDR, arg);
	      (yyvsp[(2) - (2)].node)->deref(0);
	   }
	}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 2020 "parser.ypp"
    {
	   pop_ignore_numeric_argv_ref();
	   QoreListNode *l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode *>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l || l->size() != 2) {
	      parse_error("invalid arguments to foldl operator, expected: 2-element list (fold expression and list expression), got: '%s'", get_type_name((yyvsp[(2) - (2)].node)));
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode *code_exp = l->shift();
	      AbstractQoreNode *arg = l->shift();
	      (yyval.node) = new QoreTreeNode(code_exp, OP_FOLDL, arg);
	      (yyvsp[(2) - (2)].node)->deref(0);
	   }
	}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 2034 "parser.ypp"
    {
	   pop_ignore_numeric_argv_ref();
	   QoreListNode *l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode *>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l || l->size() != 2) {
	      parse_error("invalid arguments to select operator, expected: 2-element list (list expression and select expression) got: '%s'", get_type_name((yyvsp[(2) - (2)].node)));
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode *arg = l->shift();
	      AbstractQoreNode *select_exp = l->shift();
	      (yyval.node) = new QoreTreeNode(arg, OP_SELECT, select_exp);
	      (yyvsp[(2) - (2)].node)->deref(0);
	   }
	}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 2049 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (5)].node), OP_QUESTION_MARK, make_list((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node))); }
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 2050 "parser.ypp"
    {  // pre-increment
	   if (check_lvalue((yyvsp[(2) - (2)].node))) {
	      parse_error("pre-increment expression is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_PRE_INCREMENT, 0);
        }
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 2058 "parser.ypp"
    {  // post-increment
	   if (check_lvalue((yyvsp[(1) - (2)].node))) {
	      parse_error("post-increment expression is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (2)].node), 0);
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (2)].node), OP_POST_INCREMENT, 0);
        }
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 2066 "parser.ypp"
    {  // pre-decrement
	   if (check_lvalue((yyvsp[(2) - (2)].node))) {
	      parse_error("pre-decrement expression is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_PRE_DECREMENT, 0);
        }
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 2074 "parser.ypp"
    {   // post-decrement
	   if (check_lvalue((yyvsp[(1) - (2)].node))) {
	      parse_error("post-decrement expression is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (2)].node), 0);
	   }
	   else
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (2)].node), OP_POST_DECREMENT, 0);
        }
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 2082 "parser.ypp"
    {
	   //printd(5, "1=%s (%08p), 3=%s (%08p)\n", $1->getTypeName(), $1, $3 ? $3->getTypeName() : "n/a", $3); 
	   qore_type_t t = (yyvsp[(1) - (4)].node) ? (yyvsp[(1) - (4)].node)->getType() : 0;
	   if (t == NT_BAREWORD) {
	      BarewordNode *b = reinterpret_cast<BarewordNode *>((yyvsp[(1) - (4)].node));
	      // take string from node and delete node
	      char *str = b->takeString();
	      b->deref();
	      printd(5, "parsing call %s() args=%08p %s\n", str, (yyvsp[(3) - (4)].node), (yyvsp[(3) - (4)].node) ? (yyvsp[(3) - (4)].node)->getTypeName() : "n/a");
	      (yyval.node) = new FunctionCallNode(str, makeArgs((yyvsp[(3) - (4)].node)));
	   }
	   else if (t == NT_CONSTANT) {
	      ConstantNode *c = reinterpret_cast<ConstantNode *>((yyvsp[(1) - (4)].node));
	      // take NamedScope from node and delete node
	      NamedScope *ns = c->takeName();
	      c->deref();
	      assert(ns->elements > 1);
	      printd(5, "parsing scoped call (static method or new object call) %s()\n", ns->ostr);
	      (yyval.node) = new StaticMethodCallNode(ns, makeArgs((yyvsp[(3) - (4)].node)));
	   }
	   else if (t == NT_SELF_VARREF) {
	      SelfVarrefNode *v = reinterpret_cast<SelfVarrefNode *>((yyvsp[(1) - (4)].node));
	      // take string from node and delete node
	      char *str = v->takeString();
	      v->deref();
	      printd(5, "parsing in-object method call %s()\n", str);
	      (yyval.node) = new SelfFunctionCallNode(str, makeArgs((yyvsp[(3) - (4)].node)));
	   }
	   else {
	      QoreTreeNode *tree;
	      
	      if (t == NT_TREE) {
		 tree = reinterpret_cast<QoreTreeNode *>((yyvsp[(1) - (4)].node));
		 if (!(tree->getOp() == OP_OBJECT_REF && tree->right && tree->right->getType() == NT_STRING))
		    tree = 0;
	      }
	      else
		 tree = 0;

	      if (tree) {
		 // create an object method call node
		 // take the string
		 QoreStringNode *str = reinterpret_cast<QoreStringNode *>(tree->right);
		 char *cstr = str->giveBuffer();
		 str->deref();
		 
		 //printd(5, "method call to %s: tree=%s, args=%08p %s\n", cstr, tree->left->getTypeName(), $3, $3 ? $3->getTypeName() : "n/a");

		 MethodCallNode *mc = new MethodCallNode(cstr, makeArgs((yyvsp[(3) - (4)].node)));
		 tree->right = mc;
		 tree->setOp(OP_OBJECT_FUNC_REF);
		 (yyval.node) = (yyvsp[(1) - (4)].node);
	      }
	      else {
		 (yyval.node) = 0;
		 if ((yyvsp[(1) - (4)].node) && (yyvsp[(1) - (4)].node)->getType() == NT_VARREF) {
		    VarRefNode *r = reinterpret_cast<VarRefNode *>((yyvsp[(1) - (4)].node));
		    qore_var_t vartype = r->getType();
		    if (vartype != VT_UNRESOLVED) {
		       (yyval.node) = r->makeNewCall((yyvsp[(3) - (4)].node));
		       //printd(5, "makeNewCall(%p) returned %p (%s)\n", $3, $$, get_type_name($$));
		       if (!(yyval.node))
			  parseException("INVALID-CODE-REFERENCE-CALL", "%s variable '$%s' declared as a function reference call", r->getType() == VT_GLOBAL ? "global" : "local", r->getName());
		    }
		 }
		 if (!(yyval.node)) {
		    (yyval.node) = new CallReferenceCallNode((yyvsp[(1) - (4)].node), makeArgs((yyvsp[(3) - (4)].node)));
		    //printd(5, "made new CallReferenceCallNode: %p\n", $$);
		 }
	      }
	   }
	}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 2154 "parser.ypp"
    {
	   printd(5, "parsing in-object base class method call %s()\n", (yyvsp[(1) - (4)].nscope)->ostr);
	   if (!strcmp((yyvsp[(1) - (4)].nscope)->getIdentifier(), "copy"))
	      parse_error("illegal call to base class copy method '%s'", (yyvsp[(1) - (4)].nscope)->ostr);

	   (yyval.node) = new SelfFunctionCallNode((yyvsp[(1) - (4)].nscope), makeArgs((yyvsp[(3) - (4)].node)));
	}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 2161 "parser.ypp"
    {
	   printd(5, "parsing call %s()\n", (yyvsp[(1) - (3)].string));
	   (yyval.node) = new FunctionCallNode((yyvsp[(1) - (3)].string), makeArgs((yyvsp[(2) - (3)].node)));
        }
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 2165 "parser.ypp"
    { (yyval.node) = new SelfVarrefNode((yyvsp[(1) - (1)].string)); }
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 2166 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LOG_AND, (yyvsp[(3) - (3)].node)); }
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 2167 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LOG_OR, (yyvsp[(3) - (3)].node)); }
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 2168 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_BIN_OR, (yyvsp[(3) - (3)].node)); }
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 2169 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_BIN_AND, (yyvsp[(3) - (3)].node)); }
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 2170 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_BIN_XOR, (yyvsp[(3) - (3)].node)); }
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 2171 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_REGEX_MATCH, (yyvsp[(3) - (3)].Regex));
	}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 2174 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_REGEX_NMATCH, (yyvsp[(3) - (3)].Regex));
	}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 2177 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(1) - (3)].node))) {
	      parse_error("left-hand side of regular expression substitution operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].RegexSubst));
	   }
	   else {
	      //printf("REGEX_SUBST: '%s'\n", $3->getPattern()->getBuffer());
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_REGEX_SUBST, (yyvsp[(3) - (3)].RegexSubst));
	   }
	}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 2187 "parser.ypp"
    {
	   if (check_lvalue((yyvsp[(1) - (3)].node)))  {
	      parse_error("left-hand side of transliteration operator is not an lvalue");
	      (yyval.node) = makeErrorTree((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].RegexTrans));
	   }
	   else {
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_REGEX_TRANS, (yyvsp[(3) - (3)].RegexTrans));
	   }
	}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 2197 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_REGEX_EXTRACT, (yyvsp[(3) - (3)].Regex)); }
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 2198 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LOG_GT, (yyvsp[(3) - (3)].node)); }
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 2199 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LOG_LT, (yyvsp[(3) - (3)].node)); }
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 2200 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LOG_CMP, (yyvsp[(3) - (3)].node)); }
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 2201 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LOG_EQ, (yyvsp[(3) - (3)].node)); }
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 2202 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_ABSOLUTE_EQ, (yyvsp[(3) - (3)].node)); }
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 2203 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_ABSOLUTE_NE, (yyvsp[(3) - (3)].node)); }
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 2204 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LOG_NE, (yyvsp[(3) - (3)].node)); }
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 2205 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LOG_LE, (yyvsp[(3) - (3)].node)); }
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 2206 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LOG_GE, (yyvsp[(3) - (3)].node)); }
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 2207 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_SHIFT_LEFT, (yyvsp[(3) - (3)].node)); }
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 2208 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_SHIFT_RIGHT, (yyvsp[(3) - (3)].node)); }
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 2209 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_PLUS, (yyvsp[(3) - (3)].node)); }
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 2210 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_MINUS, (yyvsp[(3) - (3)].node)); }
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 2211 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_MODULA, (yyvsp[(3) - (3)].node)); }
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 2212 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_DIV, (yyvsp[(3) - (3)].node)); }
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 2213 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_MULT, (yyvsp[(3) - (3)].node)); }
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 2214 "parser.ypp"
    { 
	   // FIXME: need to expand constant expression checking to determine
	   //        if the expression can throw an exception at run-time
	   // first check for constant expressions
	   (yyval.node) = QoreUnaryMinusOperatorNode::makeNode((yyvsp[(2) - (2)].node));
	}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 2220 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_BIN_NOT, 0); }
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 2221 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_NOT, 0); }
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 2222 "parser.ypp"
    {
	   qore_type_t t = (yyvsp[(2) - (2)].node) ? (yyvsp[(2) - (2)].node)->getType() : 0;
	   //printd(5, "backslash exp line %d, type %s\n", @2.first_line, $2->getTypeName());

	   if (t == NT_FUNCTION_CALL) {
	      FunctionCallNode *f = reinterpret_cast<FunctionCallNode *>((yyvsp[(2) - (2)].node));
	      if (f->getArgs()) {
		 parse_error("argument given to call reference");
		 (yyval.node) = (yyvsp[(2) - (2)].node);
	      }
	      else {
		 assert(!f->getFunction());
		 (yyval.node) = new UnresolvedCallReferenceNode(f->takeName());
		 f->deref();
	      }
	   }
	   else if (t == NT_SELF_CALL) {
	      (yyval.node) = reinterpret_cast<SelfFunctionCallNode *>((yyvsp[(2) - (2)].node))->makeReferenceNodeAndDeref();
	   }
	   else if (t == NT_STATIC_METHOD_CALL) {
	      StaticMethodCallNode *m = reinterpret_cast<StaticMethodCallNode *>((yyvsp[(2) - (2)].node));
	      if (m->getArgs()) {
		 parse_error("argument given to static method call reference");
		 (yyval.node) = (yyvsp[(2) - (2)].node);
	      }
	      else {
		 (yyval.node) = new UnresolvedStaticMethodCallReferenceNode(m->takeScope());
		 m->deref();
	      }
	   }
	   else {
	      bool make_ref = true;

	      if (t == NT_TREE) {
		 QoreTreeNode *tree = reinterpret_cast<QoreTreeNode *>((yyvsp[(2) - (2)].node));
		 if (tree->getOp() == OP_OBJECT_FUNC_REF) {
		    assert(tree->right->getType() == NT_METHOD_CALL);
		    MethodCallNode *m = reinterpret_cast<MethodCallNode *>(tree->right);
		    if (m->getArgs()) {
		       parse_error("argument given to call reference");
		       (yyval.node) = (yyvsp[(2) - (2)].node);
		    }
		    else { // rewrite as a call reference
		       // take components of tree and delete tree
		       AbstractQoreNode *exp = tree->left;
		       tree->left = 0;
		       char *meth = m->takeName();
		       m->deref();
		       tree->right = 0;
		       tree->deref();
		       (yyval.node) = new ParseObjectMethodReferenceNode(exp, meth);
		       //printd(5, "made parse object method reference: exp=%08p meth=%s (node=%08p)\n", exp, meth, $$);
		       make_ref = false;
		    }
		 }
	      }

	      if (make_ref) {
		 //printd(5, "type=%s\n", $2->getTypeName());
		 (yyval.node) = new ReferenceNode((yyvsp[(2) - (2)].node));
		 if (check_lvalue((yyvsp[(2) - (2)].node)))
		    parse_error("argument to reference operator is not an lvalue or a function or method");
	      }
	   }
	}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 2287 "parser.ypp"
    {
	   (yyval.node) = new ScopedObjectCallNode(new NamedScope((yyvsp[(2) - (5)].string)), makeArgs((yyvsp[(4) - (5)].node)));
	   if (checkParseOption(PO_NO_NEW))
	      parse_error("illegal use of the 'new' operator (conflicts with parse option NO_NEW)");
        }
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 2292 "parser.ypp"
    {
	   (yyval.node) = new ScopedObjectCallNode(new NamedScope((yyvsp[(2) - (5)].string)), makeArgs((yyvsp[(4) - (5)].node)));
	   if (checkParseOption(PO_NO_NEW))
	      parse_error("illegal use of the 'new' operator (conflicts with parse option NO_NEW)");
        }
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 2297 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_BACKGROUND, 0);
	   // check to see if the expression is legal
	   if (checkParseOption(PO_NO_THREAD_CONTROL))
	      parse_error("illegal use of \"background\" operator (conflicts with parse option NO_THREAD_CONTROL)");
	   else if (!hasEffect((yyvsp[(2) - (2)].node)))
	      parse_error("argument to background operator has no effect");
	}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 2305 "parser.ypp"
    {
	   (yyval.node) = new BackquoteNode((yyvsp[(1) - (1)].string));
	   if (checkParseOption(PO_NO_EXTERNAL_PROCESS))
	      parse_error("illegal use of backquote operator (conflicts with parse option NO_EXTERNAL_PROCESS)");
	}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 2310 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (4)].node), OP_LIST_REF, (yyvsp[(3) - (4)].node)); }
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 2311 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (4)].node), OP_OBJECT_REF, (yyvsp[(3) - (4)].node)); }
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 2312 "parser.ypp"
    {
	   (yyval.node) = process_dot((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 2315 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(1) - (2)].node), OP_OBJECT_REF, (yyvsp[(2) - (2)].String));
	}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 2318 "parser.ypp"
    { 
	   (yyval.node) = (yyvsp[(2) - (3)].node);
	   if ((yyvsp[(2) - (3)].node) && (yyvsp[(2) - (3)].node)->getType() == NT_LIST)
	      reinterpret_cast<QoreListNode *>((yyvsp[(2) - (3)].node))->setFinalized(); 
	}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 2323 "parser.ypp"
    { QoreListNode *l = new QoreListNode; l->setFinalized(); (yyval.node) = l; }
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 2324 "parser.ypp"
    {
	   int ar = get_pop_argv_ref();
	   (yyval.node) = new QoreClosureParseNode(new UserClosureFunction((yyvsp[(6) - (6)].sblock), (yylsp[(3) - (6)]).first_line, (yylsp[(3) - (6)]).last_line, (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].returnTypeInfo), false, ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS));
	}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 2328 "parser.ypp"
    {
	   int ar = get_pop_argv_ref();
	   (yyval.node) = new QoreClosureParseNode(new UserClosureFunction((yyvsp[(7) - (7)].sblock), (yylsp[(4) - (7)]).first_line, (yylsp[(4) - (7)]).last_line, (yyvsp[(4) - (7)].node), (yyvsp[(6) - (7)].returnTypeInfo), true, ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS));
	}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 2332 "parser.ypp"
    { 
	   (yyval.node) = (yyvsp[(1) - (1)].implicit_arg);
	   inc_numeric_argv_ref();
	}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 2336 "parser.ypp"
    {
	   (yyval.node) = new QoreDeleteOperatorNode((yyvsp[(2) - (2)].node));
	   if (check_vars((yyvsp[(2) - (2)].node)))
	      parse_error("delete operator takes only variable references as arguments");
	}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 2341 "parser.ypp"
    {
	   (yyval.node) = new QoreRemoveOperatorNode((yyvsp[(2) - (2)].node));
	   if (check_vars((yyvsp[(2) - (2)].node)))
	      parse_error("remove operator takes only variable references as arguments");
	}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 2346 "parser.ypp"
    {
           (yyval.node) = new QoreCastOperatorNode((yyvsp[(1) - (4)].string), (yyvsp[(3) - (4)].node));
	}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 2352 "parser.ypp"
    {
	   (yyval.String) = (yyvsp[(1) - (1)].String);
	}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 2355 "parser.ypp"
    {
	   (yyval.String) = (yyvsp[(1) - (2)].String);
	   (yyval.String)->concat((yyvsp[(2) - (2)].String));
	   (yyvsp[(2) - (2)].String)->deref();
	}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 2362 "parser.ypp"
    { (yyval.node) = new QoreFloatNode((yyvsp[(1) - (1)].decimal)); }
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 2363 "parser.ypp"
    { (yyval.node) = new QoreBigIntNode((yyvsp[(1) - (1)].integer)); }
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 2364 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].String); }
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 2365 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].datetime); }
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 2366 "parser.ypp"
    { (yyval.node) = null(); }
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 2367 "parser.ypp"
    { (yyval.node) = nothing(); }
    break;



/* Line 1455 of yacc.c  */
#line 7802 "parser.cpp"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (&yylloc, yyscanner, yymsg);
	  }
	else
	  {
	    yyerror (&yylloc, yyscanner, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc, yyscanner);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 2370 "parser.ypp"


